package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMAPPLY;
import cn.ibizlab.eam.core.eam_core.filter.EMAPPLYSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMAPPLYMapper extends BaseMapper<EMAPPLY>{

    Page<EMAPPLY> searchDefault(IPage page, @Param("srf") EMAPPLYSearchContext context, @Param("ew") Wrapper<EMAPPLY> wrapper) ;
    @Override
    EMAPPLY selectById(Serializable id);
    @Override
    int insert(EMAPPLY entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMAPPLY entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMAPPLY> selectByEquipid(@Param("emequipid") Serializable emequipid) ;

    List<EMAPPLY> selectByObjid(@Param("emobjectid") Serializable emobjectid) ;

    List<EMAPPLY> selectByRfoacid(@Param("emrfoacid") Serializable emrfoacid) ;

    List<EMAPPLY> selectByRfocaid(@Param("emrfocaid") Serializable emrfocaid) ;

    List<EMAPPLY> selectByRfodeid(@Param("emrfodeid") Serializable emrfodeid) ;

    List<EMAPPLY> selectByRfomoid(@Param("emrfomoid") Serializable emrfomoid) ;

    List<EMAPPLY> selectByRserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMAPPLY> selectByRdeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMAPPLY> selectByCloseempid(@Param("pfempid") Serializable pfempid) ;

    List<EMAPPLY> selectByMpersonid(@Param("pfempid") Serializable pfempid) ;

    List<EMAPPLY> selectByRempid(@Param("pfempid") Serializable pfempid) ;

    List<EMAPPLY> selectByRteamid(@Param("pfteamid") Serializable pfteamid) ;

}
