package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMASSET;
import cn.ibizlab.eam.core.eam_core.filter.EMASSETSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMASSETMapper extends BaseMapper<EMASSET>{

    Page<EMASSET> searchAssetBf(IPage page, @Param("srf") EMASSETSearchContext context, @Param("ew") Wrapper<EMASSET> wrapper) ;
    Page<EMASSET> searchDefault(IPage page, @Param("srf") EMASSETSearchContext context, @Param("ew") Wrapper<EMASSET> wrapper) ;
    @Override
    EMASSET selectById(Serializable id);
    @Override
    int insert(EMASSET entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMASSET entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMASSET> selectByAcclassid(@Param("emacclassid") Serializable emacclassid) ;

    List<EMASSET> selectByAssetclassid(@Param("emassetclassid") Serializable emassetclassid) ;

    List<EMASSET> selectByEqlocationid(@Param("emeqlocationid") Serializable emeqlocationid) ;

    List<EMASSET> selectByLabserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMASSET> selectByMserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMASSET> selectByRserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMASSET> selectByContractid(@Param("pfcontractid") Serializable pfcontractid) ;

    List<EMASSET> selectByDeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMASSET> selectByMgrdeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMASSET> selectByEmpid(@Param("pfempid") Serializable pfempid) ;

    List<EMASSET> selectByRempid(@Param("pfempid") Serializable pfempid) ;

    List<EMASSET> selectByUnitid(@Param("pfunitid") Serializable pfunitid) ;

}
