package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMEQKEEP;
import cn.ibizlab.eam.core.eam_core.filter.EMEQKEEPSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMEQKEEPMapper extends BaseMapper<EMEQKEEP>{

    Page<EMEQKEEP> searchDefault(IPage page, @Param("srf") EMEQKEEPSearchContext context, @Param("ew") Wrapper<EMEQKEEP> wrapper) ;
    @Override
    EMEQKEEP selectById(Serializable id);
    @Override
    int insert(EMEQKEEP entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMEQKEEP entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMEQKEEP> selectByAcclassid(@Param("emacclassid") Serializable emacclassid) ;

    List<EMEQKEEP> selectByEquipid(@Param("emequipid") Serializable emequipid) ;

    List<EMEQKEEP> selectByObjid(@Param("emobjectid") Serializable emobjectid) ;

    List<EMEQKEEP> selectByRfoacid(@Param("emrfoacid") Serializable emrfoacid) ;

    List<EMEQKEEP> selectByRfocaid(@Param("emrfocaid") Serializable emrfocaid) ;

    List<EMEQKEEP> selectByRfodeid(@Param("emrfodeid") Serializable emrfodeid) ;

    List<EMEQKEEP> selectByRfomoid(@Param("emrfomoid") Serializable emrfomoid) ;

    List<EMEQKEEP> selectByRserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMEQKEEP> selectByWoid(@Param("emwoid") Serializable emwoid) ;

    List<EMEQKEEP> selectByRdeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMEQKEEP> selectByRempid(@Param("pfempid") Serializable pfempid) ;

    List<EMEQKEEP> selectByRteamid(@Param("pfteamid") Serializable pfteamid) ;

}
