package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMEQMAINTANCE;
import cn.ibizlab.eam.core.eam_core.filter.EMEQMAINTANCESearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMEQMAINTANCEMapper extends BaseMapper<EMEQMAINTANCE>{

    Page<EMEQMAINTANCE> searchDefault(IPage page, @Param("srf") EMEQMAINTANCESearchContext context, @Param("ew") Wrapper<EMEQMAINTANCE> wrapper) ;
    @Override
    EMEQMAINTANCE selectById(Serializable id);
    @Override
    int insert(EMEQMAINTANCE entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMEQMAINTANCE entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMEQMAINTANCE> selectByAcclassid(@Param("emacclassid") Serializable emacclassid) ;

    List<EMEQMAINTANCE> selectByEquipid(@Param("emequipid") Serializable emequipid) ;

    List<EMEQMAINTANCE> selectByObjid(@Param("emobjectid") Serializable emobjectid) ;

    List<EMEQMAINTANCE> selectByRfoacid(@Param("emrfoacid") Serializable emrfoacid) ;

    List<EMEQMAINTANCE> selectByRfocaid(@Param("emrfocaid") Serializable emrfocaid) ;

    List<EMEQMAINTANCE> selectByRfodeid(@Param("emrfodeid") Serializable emrfodeid) ;

    List<EMEQMAINTANCE> selectByRfomoid(@Param("emrfomoid") Serializable emrfomoid) ;

    List<EMEQMAINTANCE> selectByRserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMEQMAINTANCE> selectByWoid(@Param("emwoid") Serializable emwoid) ;

    List<EMEQMAINTANCE> selectByRdeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMEQMAINTANCE> selectByRempid(@Param("pfempid") Serializable pfempid) ;

    List<EMEQMAINTANCE> selectByRteamid(@Param("pfteamid") Serializable pfteamid) ;

}
