package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMEQUIP;
import cn.ibizlab.eam.core.eam_core.filter.EMEQUIPSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMEQUIPMapper extends BaseMapper<EMEQUIP>{

    Page<HashMap> searchTypeEQNum(IPage page, @Param("srf") EMEQUIPSearchContext context, @Param("ew") Wrapper<EMEQUIP> wrapper) ;
    Page<EMEQUIP> searchDefault(IPage page, @Param("srf") EMEQUIPSearchContext context, @Param("ew") Wrapper<EMEQUIP> wrapper) ;
    @Override
    EMEQUIP selectById(Serializable id);
    @Override
    int insert(EMEQUIP entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMEQUIP entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMEQUIP> selectByAcclassid(@Param("emacclassid") Serializable emacclassid) ;

    List<EMEQUIP> selectByAssetid(@Param("emassetid") Serializable emassetid) ;

    List<EMEQUIP> selectByEmberthid(@Param("emberthid") Serializable emberthid) ;

    List<EMEQUIP> selectByEmbrandid(@Param("embrandid") Serializable embrandid) ;

    List<EMEQUIP> selectByEqlocationid(@Param("emeqlocationid") Serializable emeqlocationid) ;

    List<EMEQUIP> selectByEqtypeid(@Param("emeqtypeid") Serializable emeqtypeid) ;

    List<EMEQUIP> selectByEquippid(@Param("emequipid") Serializable emequipid) ;

    List<EMEQUIP> selectByEmmachinecategoryid(@Param("emmachinecategoryid") Serializable emmachinecategoryid) ;

    List<EMEQUIP> selectByEmmachmodelid(@Param("emmachmodelid") Serializable emmachmodelid) ;

    List<EMEQUIP> selectByLabserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMEQUIP> selectByMserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMEQUIP> selectByRserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMEQUIP> selectByContractid(@Param("pfcontractid") Serializable pfcontractid) ;

    List<EMEQUIP> selectByDeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMEQUIP> selectByEmpid(@Param("pfempid") Serializable pfempid) ;

    List<EMEQUIP> selectByRteamid(@Param("pfteamid") Serializable pfteamid) ;

}
