package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMITEMPUSE;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMPUSESearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMITEMPUSEMapper extends BaseMapper<EMITEMPUSE>{

    Page<EMITEMPUSE> searchDefault(IPage page, @Param("srf") EMITEMPUSESearchContext context, @Param("ew") Wrapper<EMITEMPUSE> wrapper) ;
    @Override
    EMITEMPUSE selectById(Serializable id);
    @Override
    int insert(EMITEMPUSE entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMITEMPUSE entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMITEMPUSE> selectByEquipid(@Param("emequipid") Serializable emequipid) ;

    List<EMITEMPUSE> selectByItemid(@Param("emitemid") Serializable emitemid) ;

    List<EMITEMPUSE> selectByObjid(@Param("emobjectid") Serializable emobjectid) ;

    List<EMITEMPUSE> selectByPurplanid(@Param("empurplanid") Serializable empurplanid) ;

    List<EMITEMPUSE> selectByLabserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMITEMPUSE> selectByMserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMITEMPUSE> selectByStorepartid(@Param("emstorepartid") Serializable emstorepartid) ;

    List<EMITEMPUSE> selectByStoreid(@Param("emstoreid") Serializable emstoreid) ;

    List<EMITEMPUSE> selectByWoid(@Param("emwoid") Serializable emwoid) ;

    List<EMITEMPUSE> selectByDeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMITEMPUSE> selectByAempid(@Param("pfempid") Serializable pfempid) ;

    List<EMITEMPUSE> selectByApprempid(@Param("pfempid") Serializable pfempid) ;

    List<EMITEMPUSE> selectByEmpid(@Param("pfempid") Serializable pfempid) ;

    List<EMITEMPUSE> selectBySempid(@Param("pfempid") Serializable pfempid) ;

    List<EMITEMPUSE> selectByTeamid(@Param("pfteamid") Serializable pfteamid) ;

}
