package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMITEMTRADE;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMTRADESearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMITEMTRADEMapper extends BaseMapper<EMITEMTRADE>{

    Page<EMITEMTRADE> searchDefault(IPage page, @Param("srf") EMITEMTRADESearchContext context, @Param("ew") Wrapper<EMITEMTRADE> wrapper) ;
    Page<EMITEMTRADE> searchIndexDER(IPage page, @Param("srf") EMITEMTRADESearchContext context, @Param("ew") Wrapper<EMITEMTRADE> wrapper) ;
    @Override
    EMITEMTRADE selectById(Serializable id);
    @Override
    int insert(EMITEMTRADE entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMITEMTRADE entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMITEMTRADE> selectByRid(@Param("emitemtradeid") Serializable emitemtradeid) ;

    List<EMITEMTRADE> selectByItemid(@Param("emitemid") Serializable emitemid) ;

    List<EMITEMTRADE> selectByLabserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMITEMTRADE> selectByStorepartid(@Param("emstorepartid") Serializable emstorepartid) ;

    List<EMITEMTRADE> selectByStoreid(@Param("emstoreid") Serializable emstoreid) ;

    List<EMITEMTRADE> selectByDeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMITEMTRADE> selectByAempid(@Param("pfempid") Serializable pfempid) ;

    List<EMITEMTRADE> selectBySempid(@Param("pfempid") Serializable pfempid) ;

    List<EMITEMTRADE> selectByTeamid(@Param("pfteamid") Serializable pfteamid) ;

}
