package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMPLANTEMPL;
import cn.ibizlab.eam.core.eam_core.filter.EMPLANTEMPLSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMPLANTEMPLMapper extends BaseMapper<EMPLANTEMPL>{

    Page<EMPLANTEMPL> searchDefault(IPage page, @Param("srf") EMPLANTEMPLSearchContext context, @Param("ew") Wrapper<EMPLANTEMPL> wrapper) ;
    @Override
    EMPLANTEMPL selectById(Serializable id);
    @Override
    int insert(EMPLANTEMPL entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMPLANTEMPL entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMPLANTEMPL> selectByAcclassid(@Param("emacclassid") Serializable emacclassid) ;

    List<EMPLANTEMPL> selectByRserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMPLANTEMPL> selectByRdeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMPLANTEMPL> selectByMpersonid(@Param("pfempid") Serializable pfempid) ;

    List<EMPLANTEMPL> selectByRecvpersonid(@Param("pfempid") Serializable pfempid) ;

    List<EMPLANTEMPL> selectByRempid(@Param("pfempid") Serializable pfempid) ;

    List<EMPLANTEMPL> selectByRteamid(@Param("pfteamid") Serializable pfteamid) ;

}
