package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMPRODUCT;
import cn.ibizlab.eam.core.eam_core.filter.EMPRODUCTSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMPRODUCTMapper extends BaseMapper<EMPRODUCT>{

    Page<EMPRODUCT> searchDefault(IPage page, @Param("srf") EMPRODUCTSearchContext context, @Param("ew") Wrapper<EMPRODUCT> wrapper) ;
    @Override
    EMPRODUCT selectById(Serializable id);
    @Override
    int insert(EMPRODUCT entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMPRODUCT entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMPRODUCT> selectByEquipid(@Param("emequipid") Serializable emequipid) ;

    List<EMPRODUCT> selectByItemid(@Param("emitemid") Serializable emitemid) ;

    List<EMPRODUCT> selectByObjid(@Param("emobjectid") Serializable emobjectid) ;

    List<EMPRODUCT> selectByServiceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMPRODUCT> selectByDeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMPRODUCT> selectByAempid(@Param("pfempid") Serializable pfempid) ;

    List<EMPRODUCT> selectByEmpid(@Param("pfempid") Serializable pfempid) ;

    List<EMPRODUCT> selectByTeamid(@Param("pfteamid") Serializable pfteamid) ;

}
