package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMWPLIST;
import cn.ibizlab.eam.core.eam_core.filter.EMWPLISTSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMWPLISTMapper extends BaseMapper<EMWPLIST>{

    Page<EMWPLIST> searchDefault(IPage page, @Param("srf") EMWPLISTSearchContext context, @Param("ew") Wrapper<EMWPLIST> wrapper) ;
    Page<EMWPLIST> searchMain6_8692(IPage page, @Param("srf") EMWPLISTSearchContext context, @Param("ew") Wrapper<EMWPLIST> wrapper) ;
    @Override
    EMWPLIST selectById(Serializable id);
    @Override
    int insert(EMWPLIST entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMWPLIST entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMWPLIST> selectByEquipid(@Param("emequipid") Serializable emequipid) ;

    List<EMWPLIST> selectByItemid(@Param("emitemid") Serializable emitemid) ;

    List<EMWPLIST> selectByObjid(@Param("emobjectid") Serializable emobjectid) ;

    List<EMWPLIST> selectByEmserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMWPLIST> selectByWplistcostid(@Param("emwplistcostid") Serializable emwplistcostid) ;

    List<EMWPLIST> selectByDeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMWPLIST> selectByAempid(@Param("pfempid") Serializable pfempid) ;

    List<EMWPLIST> selectByApprempid(@Param("pfempid") Serializable pfempid) ;

    List<EMWPLIST> selectByRempid(@Param("pfempid") Serializable pfempid) ;

    List<EMWPLIST> selectByTeamid(@Param("pfteamid") Serializable pfteamid) ;

}
