package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMACCLASS;
import cn.ibizlab.eam.core.eam_core.filter.EMACCLASSSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMACCLASS] 服务对象接口
 */
public interface IEMACCLASSService extends IService<EMACCLASS>{

    boolean save(EMACCLASS et) ;
    void saveBatch(List<EMACCLASS> list) ;
    EMACCLASS getDraft(EMACCLASS et) ;
    boolean create(EMACCLASS et) ;
    void createBatch(List<EMACCLASS> list) ;
    EMACCLASS get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMACCLASS et) ;
    boolean update(EMACCLASS et) ;
    void updateBatch(List<EMACCLASS> list) ;
    Page<EMACCLASS> searchDefault(EMACCLASSSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


