package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMAPPLY;
import cn.ibizlab.eam.core.eam_core.filter.EMAPPLYSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMAPPLY] 服务对象接口
 */
public interface IEMAPPLYService extends IService<EMAPPLY>{

    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMAPPLY et) ;
    void updateBatch(List<EMAPPLY> list) ;
    boolean checkKey(EMAPPLY et) ;
    boolean save(EMAPPLY et) ;
    void saveBatch(List<EMAPPLY> list) ;
    EMAPPLY getDraft(EMAPPLY et) ;
    boolean create(EMAPPLY et) ;
    void createBatch(List<EMAPPLY> list) ;
    EMAPPLY get(String key) ;
    Page<EMAPPLY> searchDefault(EMAPPLYSearchContext context) ;
    List<EMAPPLY> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMAPPLY> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMAPPLY> selectByRfoacid(String emrfoacid) ;
    void removeByRfoacid(String emrfoacid) ;
    List<EMAPPLY> selectByRfocaid(String emrfocaid) ;
    void removeByRfocaid(String emrfocaid) ;
    List<EMAPPLY> selectByRfodeid(String emrfodeid) ;
    void removeByRfodeid(String emrfodeid) ;
    List<EMAPPLY> selectByRfomoid(String emrfomoid) ;
    void removeByRfomoid(String emrfomoid) ;
    List<EMAPPLY> selectByRserviceid(String emserviceid) ;
    void removeByRserviceid(String emserviceid) ;
    List<EMAPPLY> selectByRdeptid(String pfdeptid) ;
    void removeByRdeptid(String pfdeptid) ;
    List<EMAPPLY> selectByCloseempid(String pfempid) ;
    void removeByCloseempid(String pfempid) ;
    List<EMAPPLY> selectByMpersonid(String pfempid) ;
    void removeByMpersonid(String pfempid) ;
    List<EMAPPLY> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMAPPLY> selectByRteamid(String pfteamid) ;
    void removeByRteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


