package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMASSESSMENTMX;
import cn.ibizlab.eam.core.eam_core.filter.EMASSESSMENTMXSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMASSESSMENTMX] 服务对象接口
 */
public interface IEMASSESSMENTMXService extends IService<EMASSESSMENTMX>{

    boolean save(EMASSESSMENTMX et) ;
    void saveBatch(List<EMASSESSMENTMX> list) ;
    boolean update(EMASSESSMENTMX et) ;
    void updateBatch(List<EMASSESSMENTMX> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMASSESSMENTMX et) ;
    boolean create(EMASSESSMENTMX et) ;
    void createBatch(List<EMASSESSMENTMX> list) ;
    EMASSESSMENTMX getDraft(EMASSESSMENTMX et) ;
    EMASSESSMENTMX get(String key) ;
    Page<EMASSESSMENTMX> searchDefault(EMASSESSMENTMXSearchContext context) ;
    List<EMASSESSMENTMX> selectByEmassessmentid(String emassessmentid) ;
    void removeByEmassessmentid(String emassessmentid) ;
    List<EMASSESSMENTMX> selectByPfempid(String pfempid) ;
    void removeByPfempid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


