package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMASSESSMENT;
import cn.ibizlab.eam.core.eam_core.filter.EMASSESSMENTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMASSESSMENT] 服务对象接口
 */
public interface IEMASSESSMENTService extends IService<EMASSESSMENT>{

    boolean save(EMASSESSMENT et) ;
    void saveBatch(List<EMASSESSMENT> list) ;
    EMASSESSMENT get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(EMASSESSMENT et) ;
    void createBatch(List<EMASSESSMENT> list) ;
    boolean update(EMASSESSMENT et) ;
    void updateBatch(List<EMASSESSMENT> list) ;
    EMASSESSMENT getDraft(EMASSESSMENT et) ;
    boolean checkKey(EMASSESSMENT et) ;
    Page<EMASSESSMENT> searchDefault(EMASSESSMENTSearchContext context) ;
    List<EMASSESSMENT> selectByPfempid(String pfempid) ;
    void removeByPfempid(String pfempid) ;
    List<EMASSESSMENT> selectByPfteamid(String pfteamid) ;
    void removeByPfteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


