package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMASSESSMX;
import cn.ibizlab.eam.core.eam_core.filter.EMASSESSMXSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMASSESSMX] 服务对象接口
 */
public interface IEMASSESSMXService extends IService<EMASSESSMX>{

    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(EMASSESSMX et) ;
    void createBatch(List<EMASSESSMX> list) ;
    EMASSESSMX getDraft(EMASSESSMX et) ;
    EMASSESSMX get(String key) ;
    boolean checkKey(EMASSESSMX et) ;
    boolean update(EMASSESSMX et) ;
    void updateBatch(List<EMASSESSMX> list) ;
    boolean save(EMASSESSMX et) ;
    void saveBatch(List<EMASSESSMX> list) ;
    Page<EMASSESSMX> searchDefault(EMASSESSMXSearchContext context) ;
    List<EMASSESSMX> selectByEmdisableassessid(String emdisableassessid) ;
    void removeByEmdisableassessid(String emdisableassessid) ;
    List<EMASSESSMX> selectByEmequipid(String emequipid) ;
    void removeByEmequipid(String emequipid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


