package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMASSESS;
import cn.ibizlab.eam.core.eam_core.filter.EMASSESSSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMASSESS] 服务对象接口
 */
public interface IEMASSESSService extends IService<EMASSESS>{

    EMASSESS get(String key) ;
    boolean create(EMASSESS et) ;
    void createBatch(List<EMASSESS> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(EMASSESS et) ;
    void saveBatch(List<EMASSESS> list) ;
    EMASSESS getDraft(EMASSESS et) ;
    boolean update(EMASSESS et) ;
    void updateBatch(List<EMASSESS> list) ;
    boolean checkKey(EMASSESS et) ;
    Page<EMASSESS> searchDefault(EMASSESSSearchContext context) ;
    List<EMASSESS> selectByPfempid(String pfempid) ;
    void removeByPfempid(String pfempid) ;
    List<EMASSESS> selectByPfteamid(String pfteamid) ;
    void removeByPfteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


