package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMASSETCLASS;
import cn.ibizlab.eam.core.eam_core.filter.EMASSETCLASSSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMASSETCLASS] 服务对象接口
 */
public interface IEMASSETCLASSService extends IService<EMASSETCLASS>{

    boolean checkKey(EMASSETCLASS et) ;
    EMASSETCLASS getDraft(EMASSETCLASS et) ;
    boolean save(EMASSETCLASS et) ;
    void saveBatch(List<EMASSETCLASS> list) ;
    boolean update(EMASSETCLASS et) ;
    void updateBatch(List<EMASSETCLASS> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(EMASSETCLASS et) ;
    void createBatch(List<EMASSETCLASS> list) ;
    EMASSETCLASS get(String key) ;
    Page<EMASSETCLASS> searchDefault(EMASSETCLASSSearchContext context) ;
    List<EMASSETCLASS> selectByAssetclasspid(String emassetclassid) ;
    void removeByAssetclasspid(String emassetclassid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


