package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMASSETCLEAR;
import cn.ibizlab.eam.core.eam_core.filter.EMASSETCLEARSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMASSETCLEAR] 服务对象接口
 */
public interface IEMASSETCLEARService extends IService<EMASSETCLEAR>{

    EMASSETCLEAR getDraft(EMASSETCLEAR et) ;
    boolean save(EMASSETCLEAR et) ;
    void saveBatch(List<EMASSETCLEAR> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMASSETCLEAR et) ;
    EMASSETCLEAR get(String key) ;
    boolean update(EMASSETCLEAR et) ;
    void updateBatch(List<EMASSETCLEAR> list) ;
    boolean create(EMASSETCLEAR et) ;
    void createBatch(List<EMASSETCLEAR> list) ;
    Page<EMASSETCLEAR> searchDefault(EMASSETCLEARSearchContext context) ;
    List<EMASSETCLEAR> selectByEmassetid(String emassetid) ;
    void removeByEmassetid(String emassetid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


