package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMASSETHIST;
import cn.ibizlab.eam.core.eam_core.filter.EMASSETHISTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMASSETHIST] 服务对象接口
 */
public interface IEMASSETHISTService extends IService<EMASSETHIST>{

    boolean update(EMASSETHIST et) ;
    void updateBatch(List<EMASSETHIST> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(EMASSETHIST et) ;
    void saveBatch(List<EMASSETHIST> list) ;
    boolean create(EMASSETHIST et) ;
    void createBatch(List<EMASSETHIST> list) ;
    boolean checkKey(EMASSETHIST et) ;
    EMASSETHIST getDraft(EMASSETHIST et) ;
    EMASSETHIST get(String key) ;
    Page<EMASSETHIST> searchDefault(EMASSETHISTSearchContext context) ;
    List<EMASSETHIST> selectByAssetid(String emassetid) ;
    void removeByAssetid(String emassetid) ;
    List<EMASSETHIST> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


