package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMASSET;
import cn.ibizlab.eam.core.eam_core.filter.EMASSETSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMASSET] 服务对象接口
 */
public interface IEMASSETService extends IService<EMASSET>{

    EMASSET get(String key) ;
    boolean save(EMASSET et) ;
    void saveBatch(List<EMASSET> list) ;
    boolean update(EMASSET et) ;
    void updateBatch(List<EMASSET> list) ;
    boolean create(EMASSET et) ;
    void createBatch(List<EMASSET> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMASSET getDraft(EMASSET et) ;
    boolean checkKey(EMASSET et) ;
    Page<EMASSET> searchAssetBf(EMASSETSearchContext context) ;
    Page<EMASSET> searchDefault(EMASSETSearchContext context) ;
    List<EMASSET> selectByAcclassid(String emacclassid) ;
    void removeByAcclassid(String emacclassid) ;
    List<EMASSET> selectByAssetclassid(String emassetclassid) ;
    void removeByAssetclassid(String emassetclassid) ;
    List<EMASSET> selectByEqlocationid(String emeqlocationid) ;
    void removeByEqlocationid(String emeqlocationid) ;
    List<EMASSET> selectByLabserviceid(String emserviceid) ;
    void removeByLabserviceid(String emserviceid) ;
    List<EMASSET> selectByMserviceid(String emserviceid) ;
    void removeByMserviceid(String emserviceid) ;
    List<EMASSET> selectByRserviceid(String emserviceid) ;
    void removeByRserviceid(String emserviceid) ;
    List<EMASSET> selectByContractid(String pfcontractid) ;
    void removeByContractid(String pfcontractid) ;
    List<EMASSET> selectByDeptid(String pfdeptid) ;
    void removeByDeptid(String pfdeptid) ;
    List<EMASSET> selectByMgrdeptid(String pfdeptid) ;
    void removeByMgrdeptid(String pfdeptid) ;
    List<EMASSET> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    List<EMASSET> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMASSET> selectByUnitid(String pfunitid) ;
    void removeByUnitid(String pfunitid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


