package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMBERTH;
import cn.ibizlab.eam.core.eam_core.filter.EMBERTHSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMBERTH] 服务对象接口
 */
public interface IEMBERTHService extends IService<EMBERTH>{

    boolean create(EMBERTH et) ;
    void createBatch(List<EMBERTH> list) ;
    EMBERTH getDraft(EMBERTH et) ;
    EMBERTH get(String key) ;
    boolean update(EMBERTH et) ;
    void updateBatch(List<EMBERTH> list) ;
    boolean save(EMBERTH et) ;
    void saveBatch(List<EMBERTH> list) ;
    boolean checkKey(EMBERTH et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<EMBERTH> searchDefault(EMBERTHSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


