package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMBIDDING;
import cn.ibizlab.eam.core.eam_core.filter.EMBIDDINGSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMBIDDING] 服务对象接口
 */
public interface IEMBIDDINGService extends IService<EMBIDDING>{

    boolean update(EMBIDDING et) ;
    void updateBatch(List<EMBIDDING> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(EMBIDDING et) ;
    void saveBatch(List<EMBIDDING> list) ;
    boolean create(EMBIDDING et) ;
    void createBatch(List<EMBIDDING> list) ;
    boolean checkKey(EMBIDDING et) ;
    EMBIDDING get(String key) ;
    EMBIDDING getDraft(EMBIDDING et) ;
    Page<EMBIDDING> searchDefault(EMBIDDINGSearchContext context) ;
    List<EMBIDDING> selectByEmserviceid(String emserviceid) ;
    void removeByEmserviceid(String emserviceid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


