package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMBIDINQUIRY;
import cn.ibizlab.eam.core.eam_core.filter.EMBIDINQUIRYSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMBIDINQUIRY] 服务对象接口
 */
public interface IEMBIDINQUIRYService extends IService<EMBIDINQUIRY>{

    boolean checkKey(EMBIDINQUIRY et) ;
    EMBIDINQUIRY get(String key) ;
    EMBIDINQUIRY getDraft(EMBIDINQUIRY et) ;
    boolean update(EMBIDINQUIRY et) ;
    void updateBatch(List<EMBIDINQUIRY> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(EMBIDINQUIRY et) ;
    void saveBatch(List<EMBIDINQUIRY> list) ;
    boolean create(EMBIDINQUIRY et) ;
    void createBatch(List<EMBIDINQUIRY> list) ;
    Page<EMBIDINQUIRY> searchDefault(EMBIDINQUIRYSearchContext context) ;
    List<EMBIDINQUIRY> selectByEmpurplanid(String empurplanid) ;
    void removeByEmpurplanid(String empurplanid) ;
    List<EMBIDINQUIRY> selectByEmserviceid(String emserviceid) ;
    void removeByEmserviceid(String emserviceid) ;
    List<EMBIDINQUIRY> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


