package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMCAB;
import cn.ibizlab.eam.core.eam_core.filter.EMCABSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMCAB] 服务对象接口
 */
public interface IEMCABService extends IService<EMCAB>{

    boolean create(EMCAB et) ;
    void createBatch(List<EMCAB> list) ;
    boolean checkKey(EMCAB et) ;
    EMCAB getDraft(EMCAB et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(EMCAB et) ;
    void saveBatch(List<EMCAB> list) ;
    EMCAB get(String key) ;
    boolean update(EMCAB et) ;
    void updateBatch(List<EMCAB> list) ;
    Page<EMCAB> searchDefault(EMCABSearchContext context) ;
    List<EMCAB> selectByEmstorepartid(String emstorepartid) ;
    void removeByEmstorepartid(String emstorepartid) ;
    List<EMCAB> selectByEmstoreid(String emstoreid) ;
    void removeByEmstoreid(String emstoreid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


