package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMCUSTOMREL;
import cn.ibizlab.eam.core.eam_core.filter.EMCUSTOMRELSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMCUSTOMREL] 服务对象接口
 */
public interface IEMCUSTOMRELService extends IService<EMCUSTOMREL>{

    boolean create(EMCUSTOMREL et) ;
    void createBatch(List<EMCUSTOMREL> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMCUSTOMREL getDraft(EMCUSTOMREL et) ;
    boolean save(EMCUSTOMREL et) ;
    void saveBatch(List<EMCUSTOMREL> list) ;
    EMCUSTOMREL get(String key) ;
    boolean checkKey(EMCUSTOMREL et) ;
    boolean update(EMCUSTOMREL et) ;
    void updateBatch(List<EMCUSTOMREL> list) ;
    Page<EMCUSTOMREL> searchDefault(EMCUSTOMRELSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


