package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMDISABLEASSESS;
import cn.ibizlab.eam.core.eam_core.filter.EMDISABLEASSESSSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMDISABLEASSESS] 服务对象接口
 */
public interface IEMDISABLEASSESSService extends IService<EMDISABLEASSESS>{

    boolean checkKey(EMDISABLEASSESS et) ;
    EMDISABLEASSESS getDraft(EMDISABLEASSESS et) ;
    boolean update(EMDISABLEASSESS et) ;
    void updateBatch(List<EMDISABLEASSESS> list) ;
    boolean create(EMDISABLEASSESS et) ;
    void createBatch(List<EMDISABLEASSESS> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(EMDISABLEASSESS et) ;
    void saveBatch(List<EMDISABLEASSESS> list) ;
    EMDISABLEASSESS get(String key) ;
    Page<EMDISABLEASSESS> searchDefault(EMDISABLEASSESSSearchContext context) ;
    List<EMDISABLEASSESS> selectByPfteamid(String pfteamid) ;
    void removeByPfteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


