package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEIBATTERYFILL;
import cn.ibizlab.eam.core.eam_core.filter.EMEIBATTERYFILLSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEIBATTERYFILL] 服务对象接口
 */
public interface IEMEIBATTERYFILLService extends IService<EMEIBATTERYFILL>{

    boolean save(EMEIBATTERYFILL et) ;
    void saveBatch(List<EMEIBATTERYFILL> list) ;
    EMEIBATTERYFILL getDraft(EMEIBATTERYFILL et) ;
    boolean create(EMEIBATTERYFILL et) ;
    void createBatch(List<EMEIBATTERYFILL> list) ;
    EMEIBATTERYFILL get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMEIBATTERYFILL et) ;
    boolean update(EMEIBATTERYFILL et) ;
    void updateBatch(List<EMEIBATTERYFILL> list) ;
    Page<EMEIBATTERYFILL> searchDefault(EMEIBATTERYFILLSearchContext context) ;
    List<EMEIBATTERYFILL> selectByEiobjid(String emeibatteryid) ;
    void removeByEiobjid(String emeibatteryid) ;
    List<EMEIBATTERYFILL> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


