package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEIBATTERYHIST;
import cn.ibizlab.eam.core.eam_core.filter.EMEIBATTERYHISTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEIBATTERYHIST] 服务对象接口
 */
public interface IEMEIBATTERYHISTService extends IService<EMEIBATTERYHIST>{

    boolean create(EMEIBATTERYHIST et) ;
    void createBatch(List<EMEIBATTERYHIST> list) ;
    boolean save(EMEIBATTERYHIST et) ;
    void saveBatch(List<EMEIBATTERYHIST> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMEIBATTERYHIST getDraft(EMEIBATTERYHIST et) ;
    EMEIBATTERYHIST get(String key) ;
    boolean update(EMEIBATTERYHIST et) ;
    void updateBatch(List<EMEIBATTERYHIST> list) ;
    boolean checkKey(EMEIBATTERYHIST et) ;
    Page<EMEIBATTERYHIST> searchDefault(EMEIBATTERYHISTSearchContext context) ;
    List<EMEIBATTERYHIST> selectByEiobjid(String emeibatteryid) ;
    void removeByEiobjid(String emeibatteryid) ;
    List<EMEIBATTERYHIST> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


