package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEIBATTERY;
import cn.ibizlab.eam.core.eam_core.filter.EMEIBATTERYSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEIBATTERY] 服务对象接口
 */
public interface IEMEIBATTERYService extends IService<EMEIBATTERY>{

    EMEIBATTERY get(String key) ;
    boolean save(EMEIBATTERY et) ;
    void saveBatch(List<EMEIBATTERY> list) ;
    EMEIBATTERY getDraft(EMEIBATTERY et) ;
    boolean update(EMEIBATTERY et) ;
    void updateBatch(List<EMEIBATTERY> list) ;
    boolean checkKey(EMEIBATTERY et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(EMEIBATTERY et) ;
    void createBatch(List<EMEIBATTERY> list) ;
    Page<EMEIBATTERY> searchDefault(EMEIBATTERYSearchContext context) ;
    List<EMEIBATTERY> selectByEqlocationid(String emeqlocationid) ;
    void removeByEqlocationid(String emeqlocationid) ;
    List<EMEIBATTERY> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEIBATTERY> selectByItempuseid(String emitempuseid) ;
    void removeByItempuseid(String emitempuseid) ;
    List<EMEIBATTERY> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


