package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEICAMSETUP;
import cn.ibizlab.eam.core.eam_core.filter.EMEICAMSETUPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEICAMSETUP] 服务对象接口
 */
public interface IEMEICAMSETUPService extends IService<EMEICAMSETUP>{

    boolean update(EMEICAMSETUP et) ;
    void updateBatch(List<EMEICAMSETUP> list) ;
    boolean save(EMEICAMSETUP et) ;
    void saveBatch(List<EMEICAMSETUP> list) ;
    boolean create(EMEICAMSETUP et) ;
    void createBatch(List<EMEICAMSETUP> list) ;
    EMEICAMSETUP get(String key) ;
    boolean checkKey(EMEICAMSETUP et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMEICAMSETUP getDraft(EMEICAMSETUP et) ;
    Page<EMEICAMSETUP> searchDefault(EMEICAMSETUPSearchContext context) ;
    List<EMEICAMSETUP> selectByEiobjid(String emeicamid) ;
    void removeByEiobjid(String emeicamid) ;
    List<EMEICAMSETUP> selectByEqlocationid(String emeqlocationid) ;
    void removeByEqlocationid(String emeqlocationid) ;
    List<EMEICAMSETUP> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEICAMSETUP> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


