package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEICAM;
import cn.ibizlab.eam.core.eam_core.filter.EMEICAMSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEICAM] 服务对象接口
 */
public interface IEMEICAMService extends IService<EMEICAM>{

    EMEICAM get(String key) ;
    boolean checkKey(EMEICAM et) ;
    boolean save(EMEICAM et) ;
    void saveBatch(List<EMEICAM> list) ;
    EMEICAM getDraft(EMEICAM et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMEICAM et) ;
    void updateBatch(List<EMEICAM> list) ;
    boolean create(EMEICAM et) ;
    void createBatch(List<EMEICAM> list) ;
    Page<EMEICAM> searchDefault(EMEICAMSearchContext context) ;
    List<EMEICAM> selectByEqlocationid(String emeqlocationid) ;
    void removeByEqlocationid(String emeqlocationid) ;
    List<EMEICAM> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEICAM> selectByItempuseid(String emitempuseid) ;
    void removeByItempuseid(String emitempuseid) ;
    List<EMEICAM> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


