package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEICELLHIST;
import cn.ibizlab.eam.core.eam_core.filter.EMEICELLHISTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEICELLHIST] 服务对象接口
 */
public interface IEMEICELLHISTService extends IService<EMEICELLHIST>{

    boolean checkKey(EMEICELLHIST et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMEICELLHIST get(String key) ;
    boolean save(EMEICELLHIST et) ;
    void saveBatch(List<EMEICELLHIST> list) ;
    EMEICELLHIST getDraft(EMEICELLHIST et) ;
    boolean create(EMEICELLHIST et) ;
    void createBatch(List<EMEICELLHIST> list) ;
    boolean update(EMEICELLHIST et) ;
    void updateBatch(List<EMEICELLHIST> list) ;
    Page<EMEICELLHIST> searchDefault(EMEICELLHISTSearchContext context) ;
    List<EMEICELLHIST> selectByEiobjid(String emeicellid) ;
    void removeByEiobjid(String emeicellid) ;
    List<EMEICELLHIST> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


