package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEICELLRETURN;
import cn.ibizlab.eam.core.eam_core.filter.EMEICELLRETURNSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEICELLRETURN] 服务对象接口
 */
public interface IEMEICELLRETURNService extends IService<EMEICELLRETURN>{

    boolean checkKey(EMEICELLRETURN et) ;
    boolean save(EMEICELLRETURN et) ;
    void saveBatch(List<EMEICELLRETURN> list) ;
    boolean create(EMEICELLRETURN et) ;
    void createBatch(List<EMEICELLRETURN> list) ;
    EMEICELLRETURN get(String key) ;
    EMEICELLRETURN getDraft(EMEICELLRETURN et) ;
    boolean update(EMEICELLRETURN et) ;
    void updateBatch(List<EMEICELLRETURN> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<EMEICELLRETURN> searchDefault(EMEICELLRETURNSearchContext context) ;
    List<EMEICELLRETURN> selectByEiobjid(String emeicellid) ;
    void removeByEiobjid(String emeicellid) ;
    List<EMEICELLRETURN> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


