package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEICELLSETUP;
import cn.ibizlab.eam.core.eam_core.filter.EMEICELLSETUPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEICELLSETUP] 服务对象接口
 */
public interface IEMEICELLSETUPService extends IService<EMEICELLSETUP>{

    boolean create(EMEICELLSETUP et) ;
    void createBatch(List<EMEICELLSETUP> list) ;
    EMEICELLSETUP getDraft(EMEICELLSETUP et) ;
    boolean save(EMEICELLSETUP et) ;
    void saveBatch(List<EMEICELLSETUP> list) ;
    EMEICELLSETUP get(String key) ;
    boolean checkKey(EMEICELLSETUP et) ;
    boolean update(EMEICELLSETUP et) ;
    void updateBatch(List<EMEICELLSETUP> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<EMEICELLSETUP> searchDefault(EMEICELLSETUPSearchContext context) ;
    List<EMEICELLSETUP> selectByEiobjid(String emeicellid) ;
    void removeByEiobjid(String emeicellid) ;
    List<EMEICELLSETUP> selectByEqlocationid(String emeqlocationid) ;
    void removeByEqlocationid(String emeqlocationid) ;
    List<EMEICELLSETUP> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEICELLSETUP> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


