package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEICELL;
import cn.ibizlab.eam.core.eam_core.filter.EMEICELLSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEICELL] 服务对象接口
 */
public interface IEMEICELLService extends IService<EMEICELL>{

    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMEICELL et) ;
    void updateBatch(List<EMEICELL> list) ;
    boolean create(EMEICELL et) ;
    void createBatch(List<EMEICELL> list) ;
    boolean save(EMEICELL et) ;
    void saveBatch(List<EMEICELL> list) ;
    EMEICELL getDraft(EMEICELL et) ;
    EMEICELL get(String key) ;
    boolean checkKey(EMEICELL et) ;
    Page<EMEICELL> searchDefault(EMEICELLSearchContext context) ;
    List<EMEICELL> selectByEqlocationid(String emeqlocationid) ;
    void removeByEqlocationid(String emeqlocationid) ;
    List<EMEICELL> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEICELL> selectByItempuseid(String emitempuseid) ;
    void removeByItempuseid(String emitempuseid) ;
    List<EMEICELL> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    List<EMEICELL> selectByLyrid(String pfempid) ;
    void removeByLyrid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


