package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEIREPORTM;
import cn.ibizlab.eam.core.eam_core.filter.EMEIREPORTMSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEIREPORTM] 服务对象接口
 */
public interface IEMEIREPORTMService extends IService<EMEIREPORTM>{

    EMEIREPORTM getDraft(EMEIREPORTM et) ;
    boolean create(EMEIREPORTM et) ;
    void createBatch(List<EMEIREPORTM> list) ;
    boolean save(EMEIREPORTM et) ;
    void saveBatch(List<EMEIREPORTM> list) ;
    boolean checkKey(EMEIREPORTM et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMEIREPORTM et) ;
    void updateBatch(List<EMEIREPORTM> list) ;
    EMEIREPORTM get(String key) ;
    Page<EMEIREPORTM> searchDefault(EMEIREPORTMSearchContext context) ;
    List<EMEIREPORTM> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


