package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEITIRES;
import cn.ibizlab.eam.core.eam_core.filter.EMEITIRESSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEITIRES] 服务对象接口
 */
public interface IEMEITIRESService extends IService<EMEITIRES>{

    EMEITIRES getDraft(EMEITIRES et) ;
    boolean save(EMEITIRES et) ;
    void saveBatch(List<EMEITIRES> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(EMEITIRES et) ;
    void createBatch(List<EMEITIRES> list) ;
    EMEITIRES get(String key) ;
    boolean checkKey(EMEITIRES et) ;
    boolean update(EMEITIRES et) ;
    void updateBatch(List<EMEITIRES> list) ;
    Page<EMEITIRES> searchDefault(EMEITIRESSearchContext context) ;
    List<EMEITIRES> selectByEqlocationid(String emeqlocationid) ;
    void removeByEqlocationid(String emeqlocationid) ;
    List<EMEITIRES> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEITIRES> selectByItempuseid(String emitempuseid) ;
    void removeByItempuseid(String emitempuseid) ;
    List<EMEITIRES> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


