package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEITOOL;
import cn.ibizlab.eam.core.eam_core.filter.EMEITOOLSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEITOOL] 服务对象接口
 */
public interface IEMEITOOLService extends IService<EMEITOOL>{

    boolean checkKey(EMEITOOL et) ;
    EMEITOOL get(String key) ;
    boolean create(EMEITOOL et) ;
    void createBatch(List<EMEITOOL> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMEITOOL et) ;
    void updateBatch(List<EMEITOOL> list) ;
    boolean save(EMEITOOL et) ;
    void saveBatch(List<EMEITOOL> list) ;
    EMEITOOL getDraft(EMEITOOL et) ;
    Page<EMEITOOL> searchDefault(EMEITOOLSearchContext context) ;
    List<EMEITOOL> selectByEqlocationid(String emeqlocationid) ;
    void removeByEqlocationid(String emeqlocationid) ;
    List<EMEITOOL> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEITOOL> selectByItempuseid(String emitempuseid) ;
    void removeByItempuseid(String emitempuseid) ;
    List<EMEITOOL> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


