package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMENCONSUM;
import cn.ibizlab.eam.core.eam_core.filter.EMENCONSUMSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMENCONSUM] 服务对象接口
 */
public interface IEMENCONSUMService extends IService<EMENCONSUM>{

    boolean save(EMENCONSUM et) ;
    void saveBatch(List<EMENCONSUM> list) ;
    EMENCONSUM get(String key) ;
    boolean update(EMENCONSUM et) ;
    void updateBatch(List<EMENCONSUM> list) ;
    boolean create(EMENCONSUM et) ;
    void createBatch(List<EMENCONSUM> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMENCONSUM getDraft(EMENCONSUM et) ;
    boolean checkKey(EMENCONSUM et) ;
    Page<EMENCONSUM> searchDefault(EMENCONSUMSearchContext context) ;
    List<EMENCONSUM> selectByEnid(String emenid) ;
    void removeByEnid(String emenid) ;
    List<EMENCONSUM> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMENCONSUM> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMENCONSUM> selectByWoid(String emwoid) ;
    void removeByWoid(String emwoid) ;
    List<EMENCONSUM> selectByDeptid(String pfdeptid) ;
    void removeByDeptid(String pfdeptid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


