package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQCHECK;
import cn.ibizlab.eam.core.eam_core.filter.EMEQCHECKSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQCHECK] 服务对象接口
 */
public interface IEMEQCHECKService extends IService<EMEQCHECK>{

    boolean save(EMEQCHECK et) ;
    void saveBatch(List<EMEQCHECK> list) ;
    boolean update(EMEQCHECK et) ;
    void updateBatch(List<EMEQCHECK> list) ;
    boolean create(EMEQCHECK et) ;
    void createBatch(List<EMEQCHECK> list) ;
    EMEQCHECK getDraft(EMEQCHECK et) ;
    EMEQCHECK get(String key) ;
    boolean checkKey(EMEQCHECK et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<EMEQCHECK> searchDefault(EMEQCHECKSearchContext context) ;
    List<EMEQCHECK> selectByAcclassid(String emacclassid) ;
    void removeByAcclassid(String emacclassid) ;
    List<EMEQCHECK> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEQCHECK> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMEQCHECK> selectByRfoacid(String emrfoacid) ;
    void removeByRfoacid(String emrfoacid) ;
    List<EMEQCHECK> selectByRfocaid(String emrfocaid) ;
    void removeByRfocaid(String emrfocaid) ;
    List<EMEQCHECK> selectByRfodeid(String emrfodeid) ;
    void removeByRfodeid(String emrfodeid) ;
    List<EMEQCHECK> selectByRfomoid(String emrfomoid) ;
    void removeByRfomoid(String emrfomoid) ;
    List<EMEQCHECK> selectByRserviceid(String emserviceid) ;
    void removeByRserviceid(String emserviceid) ;
    List<EMEQCHECK> selectByWoid(String emwoid) ;
    void removeByWoid(String emwoid) ;
    List<EMEQCHECK> selectByRdeptid(String pfdeptid) ;
    void removeByRdeptid(String pfdeptid) ;
    List<EMEQCHECK> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMEQCHECK> selectByRteamid(String pfteamid) ;
    void removeByRteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


