package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQDEBUG;
import cn.ibizlab.eam.core.eam_core.filter.EMEQDEBUGSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQDEBUG] 服务对象接口
 */
public interface IEMEQDEBUGService extends IService<EMEQDEBUG>{

    EMEQDEBUG get(String key) ;
    boolean create(EMEQDEBUG et) ;
    void createBatch(List<EMEQDEBUG> list) ;
    boolean save(EMEQDEBUG et) ;
    void saveBatch(List<EMEQDEBUG> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMEQDEBUG getDraft(EMEQDEBUG et) ;
    boolean update(EMEQDEBUG et) ;
    void updateBatch(List<EMEQDEBUG> list) ;
    boolean checkKey(EMEQDEBUG et) ;
    Page<EMEQDEBUG> searchDefault(EMEQDEBUGSearchContext context) ;
    List<EMEQDEBUG> selectByAcclassid(String emacclassid) ;
    void removeByAcclassid(String emacclassid) ;
    List<EMEQDEBUG> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEQDEBUG> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMEQDEBUG> selectByRfoacid(String emrfoacid) ;
    void removeByRfoacid(String emrfoacid) ;
    List<EMEQDEBUG> selectByRfocaid(String emrfocaid) ;
    void removeByRfocaid(String emrfocaid) ;
    List<EMEQDEBUG> selectByRfodeid(String emrfodeid) ;
    void removeByRfodeid(String emrfodeid) ;
    List<EMEQDEBUG> selectByRfomoid(String emrfomoid) ;
    void removeByRfomoid(String emrfomoid) ;
    List<EMEQDEBUG> selectByRserviceid(String emserviceid) ;
    void removeByRserviceid(String emserviceid) ;
    List<EMEQDEBUG> selectByWoid(String emwoid) ;
    void removeByWoid(String emwoid) ;
    List<EMEQDEBUG> selectByRdeptid(String pfdeptid) ;
    void removeByRdeptid(String pfdeptid) ;
    List<EMEQDEBUG> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMEQDEBUG> selectByRteamid(String pfteamid) ;
    void removeByRteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


