package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQKEEP;
import cn.ibizlab.eam.core.eam_core.filter.EMEQKEEPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQKEEP] 服务对象接口
 */
public interface IEMEQKEEPService extends IService<EMEQKEEP>{

    boolean checkKey(EMEQKEEP et) ;
    boolean save(EMEQKEEP et) ;
    void saveBatch(List<EMEQKEEP> list) ;
    EMEQKEEP getDraft(EMEQKEEP et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMEQKEEP et) ;
    void updateBatch(List<EMEQKEEP> list) ;
    boolean create(EMEQKEEP et) ;
    void createBatch(List<EMEQKEEP> list) ;
    EMEQKEEP get(String key) ;
    Page<EMEQKEEP> searchDefault(EMEQKEEPSearchContext context) ;
    List<EMEQKEEP> selectByAcclassid(String emacclassid) ;
    void removeByAcclassid(String emacclassid) ;
    List<EMEQKEEP> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEQKEEP> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMEQKEEP> selectByRfoacid(String emrfoacid) ;
    void removeByRfoacid(String emrfoacid) ;
    List<EMEQKEEP> selectByRfocaid(String emrfocaid) ;
    void removeByRfocaid(String emrfocaid) ;
    List<EMEQKEEP> selectByRfodeid(String emrfodeid) ;
    void removeByRfodeid(String emrfodeid) ;
    List<EMEQKEEP> selectByRfomoid(String emrfomoid) ;
    void removeByRfomoid(String emrfomoid) ;
    List<EMEQKEEP> selectByRserviceid(String emserviceid) ;
    void removeByRserviceid(String emserviceid) ;
    List<EMEQKEEP> selectByWoid(String emwoid) ;
    void removeByWoid(String emwoid) ;
    List<EMEQKEEP> selectByRdeptid(String pfdeptid) ;
    void removeByRdeptid(String pfdeptid) ;
    List<EMEQKEEP> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMEQKEEP> selectByRteamid(String pfteamid) ;
    void removeByRteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


