package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQKPMAP;
import cn.ibizlab.eam.core.eam_core.filter.EMEQKPMAPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQKPMAP] 服务对象接口
 */
public interface IEMEQKPMAPService extends IService<EMEQKPMAP>{

    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMEQKPMAP getDraft(EMEQKPMAP et) ;
    boolean update(EMEQKPMAP et) ;
    void updateBatch(List<EMEQKPMAP> list) ;
    boolean create(EMEQKPMAP et) ;
    void createBatch(List<EMEQKPMAP> list) ;
    EMEQKPMAP get(String key) ;
    boolean checkKey(EMEQKPMAP et) ;
    boolean save(EMEQKPMAP et) ;
    void saveBatch(List<EMEQKPMAP> list) ;
    Page<EMEQKPMAP> searchDefault(EMEQKPMAPSearchContext context) ;
    List<EMEQKPMAP> selectByKpid(String emeqkpid) ;
    void removeByKpid(String emeqkpid) ;
    List<EMEQKPMAP> selectByRefobjid(String emobjectid) ;
    void removeByRefobjid(String emobjectid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


