package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQLCTMAP;
import cn.ibizlab.eam.core.eam_core.filter.EMEQLCTMAPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQLCTMAP] 服务对象接口
 */
public interface IEMEQLCTMAPService extends IService<EMEQLCTMAP>{

    boolean save(EMEQLCTMAP et) ;
    void saveBatch(List<EMEQLCTMAP> list) ;
    boolean update(EMEQLCTMAP et) ;
    void updateBatch(List<EMEQLCTMAP> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMEQLCTMAP et) ;
    EMEQLCTMAP get(String key) ;
    EMEQLCTMAP getDraft(EMEQLCTMAP et) ;
    boolean create(EMEQLCTMAP et) ;
    void createBatch(List<EMEQLCTMAP> list) ;
    Page<EMEQLCTMAP> searchDefault(EMEQLCTMAPSearchContext context) ;
    List<EMEQLCTMAP> selectByEqlocationid(String emeqlocationid) ;
    void removeByEqlocationid(String emeqlocationid) ;
    List<EMEQLCTMAP> selectByEqlocationpid(String emeqlocationid) ;
    void removeByEqlocationpid(String emeqlocationid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


