package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQLCTTIRES;
import cn.ibizlab.eam.core.eam_core.filter.EMEQLCTTIRESSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQLCTTIRES] 服务对象接口
 */
public interface IEMEQLCTTIRESService extends IService<EMEQLCTTIRES>{

    EMEQLCTTIRES getDraft(EMEQLCTTIRES et) ;
    boolean create(EMEQLCTTIRES et) ;
    void createBatch(List<EMEQLCTTIRES> list) ;
    boolean save(EMEQLCTTIRES et) ;
    void saveBatch(List<EMEQLCTTIRES> list) ;
    EMEQLCTTIRES get(String key) ;
    boolean checkKey(EMEQLCTTIRES et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMEQLCTTIRES et) ;
    void updateBatch(List<EMEQLCTTIRES> list) ;
    Page<EMEQLCTTIRES> searchDefault(EMEQLCTTIRESSearchContext context) ;
    List<EMEQLCTTIRES> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEQLCTTIRES> selectByLabserviceid(String emserviceid) ;
    void removeByLabserviceid(String emserviceid) ;
    List<EMEQLCTTIRES> selectByMserviceid(String emserviceid) ;
    void removeByMserviceid(String emserviceid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


