package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQLOCATION;
import cn.ibizlab.eam.core.eam_core.filter.EMEQLOCATIONSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQLOCATION] 服务对象接口
 */
public interface IEMEQLOCATIONService extends IService<EMEQLOCATION>{

    boolean update(EMEQLOCATION et) ;
    void updateBatch(List<EMEQLOCATION> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMEQLOCATION getDraft(EMEQLOCATION et) ;
    boolean checkKey(EMEQLOCATION et) ;
    boolean save(EMEQLOCATION et) ;
    void saveBatch(List<EMEQLOCATION> list) ;
    boolean create(EMEQLOCATION et) ;
    void createBatch(List<EMEQLOCATION> list) ;
    EMEQLOCATION get(String key) ;
    Page<EMEQLOCATION> searchDefault(EMEQLOCATIONSearchContext context) ;
    List<EMEQLOCATION> selectByMajorequipid(String emequipid) ;
    void removeByMajorequipid(String emequipid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


