package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQMAINTANCE;
import cn.ibizlab.eam.core.eam_core.filter.EMEQMAINTANCESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQMAINTANCE] 服务对象接口
 */
public interface IEMEQMAINTANCEService extends IService<EMEQMAINTANCE>{

    boolean update(EMEQMAINTANCE et) ;
    void updateBatch(List<EMEQMAINTANCE> list) ;
    boolean checkKey(EMEQMAINTANCE et) ;
    EMEQMAINTANCE get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(EMEQMAINTANCE et) ;
    void saveBatch(List<EMEQMAINTANCE> list) ;
    boolean create(EMEQMAINTANCE et) ;
    void createBatch(List<EMEQMAINTANCE> list) ;
    EMEQMAINTANCE getDraft(EMEQMAINTANCE et) ;
    Page<EMEQMAINTANCE> searchDefault(EMEQMAINTANCESearchContext context) ;
    List<EMEQMAINTANCE> selectByAcclassid(String emacclassid) ;
    void removeByAcclassid(String emacclassid) ;
    List<EMEQMAINTANCE> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEQMAINTANCE> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMEQMAINTANCE> selectByRfoacid(String emrfoacid) ;
    void removeByRfoacid(String emrfoacid) ;
    List<EMEQMAINTANCE> selectByRfocaid(String emrfocaid) ;
    void removeByRfocaid(String emrfocaid) ;
    List<EMEQMAINTANCE> selectByRfodeid(String emrfodeid) ;
    void removeByRfodeid(String emrfodeid) ;
    List<EMEQMAINTANCE> selectByRfomoid(String emrfomoid) ;
    void removeByRfomoid(String emrfomoid) ;
    List<EMEQMAINTANCE> selectByRserviceid(String emserviceid) ;
    void removeByRserviceid(String emserviceid) ;
    List<EMEQMAINTANCE> selectByWoid(String emwoid) ;
    void removeByWoid(String emwoid) ;
    List<EMEQMAINTANCE> selectByRdeptid(String pfdeptid) ;
    void removeByRdeptid(String pfdeptid) ;
    List<EMEQMAINTANCE> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMEQMAINTANCE> selectByRteamid(String pfteamid) ;
    void removeByRteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


