package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQMONITOR;
import cn.ibizlab.eam.core.eam_core.filter.EMEQMONITORSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQMONITOR] 服务对象接口
 */
public interface IEMEQMONITORService extends IService<EMEQMONITOR>{

    boolean create(EMEQMONITOR et) ;
    void createBatch(List<EMEQMONITOR> list) ;
    boolean save(EMEQMONITOR et) ;
    void saveBatch(List<EMEQMONITOR> list) ;
    boolean checkKey(EMEQMONITOR et) ;
    boolean update(EMEQMONITOR et) ;
    void updateBatch(List<EMEQMONITOR> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMEQMONITOR get(String key) ;
    EMEQMONITOR getDraft(EMEQMONITOR et) ;
    Page<EMEQMONITOR> searchDefault(EMEQMONITORSearchContext context) ;
    List<EMEQMONITOR> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEQMONITOR> selectByWoid(String emwoid) ;
    void removeByWoid(String emwoid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


