package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQSETUP;
import cn.ibizlab.eam.core.eam_core.filter.EMEQSETUPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQSETUP] 服务对象接口
 */
public interface IEMEQSETUPService extends IService<EMEQSETUP>{

    boolean save(EMEQSETUP et) ;
    void saveBatch(List<EMEQSETUP> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMEQSETUP get(String key) ;
    boolean checkKey(EMEQSETUP et) ;
    EMEQSETUP getDraft(EMEQSETUP et) ;
    boolean update(EMEQSETUP et) ;
    void updateBatch(List<EMEQSETUP> list) ;
    boolean create(EMEQSETUP et) ;
    void createBatch(List<EMEQSETUP> list) ;
    Page<EMEQSETUP> searchDefault(EMEQSETUPSearchContext context) ;
    List<EMEQSETUP> selectByAcclassid(String emacclassid) ;
    void removeByAcclassid(String emacclassid) ;
    List<EMEQSETUP> selectByEitiresid(String emeitiresid) ;
    void removeByEitiresid(String emeitiresid) ;
    List<EMEQSETUP> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEQSETUP> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMEQSETUP> selectByRfoacid(String emrfoacid) ;
    void removeByRfoacid(String emrfoacid) ;
    List<EMEQSETUP> selectByRfocaid(String emrfocaid) ;
    void removeByRfocaid(String emrfocaid) ;
    List<EMEQSETUP> selectByRfodeid(String emrfodeid) ;
    void removeByRfodeid(String emrfodeid) ;
    List<EMEQSETUP> selectByRfomoid(String emrfomoid) ;
    void removeByRfomoid(String emrfomoid) ;
    List<EMEQSETUP> selectByRserviceid(String emserviceid) ;
    void removeByRserviceid(String emserviceid) ;
    List<EMEQSETUP> selectByWoid(String emwoid) ;
    void removeByWoid(String emwoid) ;
    List<EMEQSETUP> selectByRdeptid(String pfdeptid) ;
    void removeByRdeptid(String pfdeptid) ;
    List<EMEQSETUP> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMEQSETUP> selectByRteamid(String pfteamid) ;
    void removeByRteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


