package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQSPAREDETAIL;
import cn.ibizlab.eam.core.eam_core.filter.EMEQSPAREDETAILSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQSPAREDETAIL] 服务对象接口
 */
public interface IEMEQSPAREDETAILService extends IService<EMEQSPAREDETAIL>{

    EMEQSPAREDETAIL get(String key) ;
    boolean create(EMEQSPAREDETAIL et) ;
    void createBatch(List<EMEQSPAREDETAIL> list) ;
    boolean update(EMEQSPAREDETAIL et) ;
    void updateBatch(List<EMEQSPAREDETAIL> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMEQSPAREDETAIL et) ;
    EMEQSPAREDETAIL getDraft(EMEQSPAREDETAIL et) ;
    boolean save(EMEQSPAREDETAIL et) ;
    void saveBatch(List<EMEQSPAREDETAIL> list) ;
    Page<EMEQSPAREDETAIL> searchDefault(EMEQSPAREDETAILSearchContext context) ;
    List<EMEQSPAREDETAIL> selectByEqspareid(String emeqspareid) ;
    void removeByEqspareid(String emeqspareid) ;
    List<EMEQSPAREDETAIL> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


