package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQSPARE;
import cn.ibizlab.eam.core.eam_core.filter.EMEQSPARESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQSPARE] 服务对象接口
 */
public interface IEMEQSPAREService extends IService<EMEQSPARE>{

    boolean update(EMEQSPARE et) ;
    void updateBatch(List<EMEQSPARE> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMEQSPARE et) ;
    boolean create(EMEQSPARE et) ;
    void createBatch(List<EMEQSPARE> list) ;
    boolean save(EMEQSPARE et) ;
    void saveBatch(List<EMEQSPARE> list) ;
    EMEQSPARE getDraft(EMEQSPARE et) ;
    EMEQSPARE get(String key) ;
    Page<EMEQSPARE> searchDefault(EMEQSPARESearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


