package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQSTOPMONI;
import cn.ibizlab.eam.core.eam_core.filter.EMEQSTOPMONISearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQSTOPMONI] 服务对象接口
 */
public interface IEMEQSTOPMONIService extends IService<EMEQSTOPMONI>{

    boolean checkKey(EMEQSTOPMONI et) ;
    boolean create(EMEQSTOPMONI et) ;
    void createBatch(List<EMEQSTOPMONI> list) ;
    EMEQSTOPMONI getDraft(EMEQSTOPMONI et) ;
    boolean save(EMEQSTOPMONI et) ;
    void saveBatch(List<EMEQSTOPMONI> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMEQSTOPMONI et) ;
    void updateBatch(List<EMEQSTOPMONI> list) ;
    EMEQSTOPMONI get(String key) ;
    Page<EMEQSTOPMONI> searchDefault(EMEQSTOPMONISearchContext context) ;
    List<EMEQSTOPMONI> selectByEmeqstopid(String emeqstopid) ;
    void removeByEmeqstopid(String emeqstopid) ;
    List<EMEQSTOPMONI> selectByEmeqtypeid(String emeqtypeid) ;
    void removeByEmeqtypeid(String emeqtypeid) ;
    List<EMEQSTOPMONI> selectByEmequipid(String emequipid) ;
    void removeByEmequipid(String emequipid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


