package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQSTOP;
import cn.ibizlab.eam.core.eam_core.filter.EMEQSTOPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQSTOP] 服务对象接口
 */
public interface IEMEQSTOPService extends IService<EMEQSTOP>{

    EMEQSTOP get(String key) ;
    boolean checkKey(EMEQSTOP et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMEQSTOP et) ;
    void updateBatch(List<EMEQSTOP> list) ;
    EMEQSTOP getDraft(EMEQSTOP et) ;
    boolean create(EMEQSTOP et) ;
    void createBatch(List<EMEQSTOP> list) ;
    boolean save(EMEQSTOP et) ;
    void saveBatch(List<EMEQSTOP> list) ;
    Page<EMEQSTOP> searchDefault(EMEQSTOPSearchContext context) ;
    List<EMEQSTOP> selectByEmeqtypeid(String emeqtypeid) ;
    void removeByEmeqtypeid(String emeqtypeid) ;
    List<EMEQSTOP> selectByEmequipid(String emequipid) ;
    void removeByEmequipid(String emequipid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


