package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMEQUIP;
import cn.ibizlab.eam.core.eam_core.filter.EMEQUIPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQUIP] 服务对象接口
 */
public interface IEMEQUIPService extends IService<EMEQUIP>{

    boolean update(EMEQUIP et) ;
    void updateBatch(List<EMEQUIP> list) ;
    boolean create(EMEQUIP et) ;
    void createBatch(List<EMEQUIP> list) ;
    boolean checkKey(EMEQUIP et) ;
    EMEQUIP get(String key) ;
    boolean save(EMEQUIP et) ;
    void saveBatch(List<EMEQUIP> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMEQUIP getDraft(EMEQUIP et) ;
    Page<HashMap> searchTypeEQNum(EMEQUIPSearchContext context) ;
    Page<EMEQUIP> searchDefault(EMEQUIPSearchContext context) ;
    List<EMEQUIP> selectByAcclassid(String emacclassid) ;
    void removeByAcclassid(String emacclassid) ;
    List<EMEQUIP> selectByAssetid(String emassetid) ;
    void removeByAssetid(String emassetid) ;
    List<EMEQUIP> selectByEmberthid(String emberthid) ;
    void removeByEmberthid(String emberthid) ;
    List<EMEQUIP> selectByEmbrandid(String embrandid) ;
    void removeByEmbrandid(String embrandid) ;
    List<EMEQUIP> selectByEqlocationid(String emeqlocationid) ;
    void removeByEqlocationid(String emeqlocationid) ;
    List<EMEQUIP> selectByEqtypeid(String emeqtypeid) ;
    void removeByEqtypeid(String emeqtypeid) ;
    List<EMEQUIP> selectByEquippid(String emequipid) ;
    void removeByEquippid(String emequipid) ;
    List<EMEQUIP> selectByEmmachinecategoryid(String emmachinecategoryid) ;
    void removeByEmmachinecategoryid(String emmachinecategoryid) ;
    List<EMEQUIP> selectByEmmachmodelid(String emmachmodelid) ;
    void removeByEmmachmodelid(String emmachmodelid) ;
    List<EMEQUIP> selectByLabserviceid(String emserviceid) ;
    void removeByLabserviceid(String emserviceid) ;
    List<EMEQUIP> selectByMserviceid(String emserviceid) ;
    void removeByMserviceid(String emserviceid) ;
    List<EMEQUIP> selectByRserviceid(String emserviceid) ;
    void removeByRserviceid(String emserviceid) ;
    List<EMEQUIP> selectByContractid(String pfcontractid) ;
    void removeByContractid(String pfcontractid) ;
    List<EMEQUIP> selectByDeptid(String pfdeptid) ;
    void removeByDeptid(String pfdeptid) ;
    List<EMEQUIP> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    List<EMEQUIP> selectByRteamid(String pfteamid) ;
    void removeByRteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


