package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMITEMCS;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMCSSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMITEMCS] 服务对象接口
 */
public interface IEMITEMCSService extends IService<EMITEMCS>{

    boolean create(EMITEMCS et) ;
    void createBatch(List<EMITEMCS> list) ;
    EMITEMCS getDraft(EMITEMCS et) ;
    boolean checkKey(EMITEMCS et) ;
    boolean update(EMITEMCS et) ;
    void updateBatch(List<EMITEMCS> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(EMITEMCS et) ;
    void saveBatch(List<EMITEMCS> list) ;
    EMITEMCS get(String key) ;
    Page<EMITEMCS> searchDefault(EMITEMCSSearchContext context) ;
    List<EMITEMCS> selectByRid(String emitemrinid) ;
    void removeByRid(String emitemrinid) ;
    List<EMITEMCS> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMITEMCS> selectByStockid(String emstockid) ;
    void removeByStockid(String emstockid) ;
    List<EMITEMCS> selectByStorepartid(String emstorepartid) ;
    void removeByStorepartid(String emstorepartid) ;
    List<EMITEMCS> selectByStoreid(String emstoreid) ;
    void removeByStoreid(String emstoreid) ;
    List<EMITEMCS> selectBySempid(String pfempid) ;
    void removeBySempid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


