package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMITEMPL;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMPLSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMITEMPL] 服务对象接口
 */
public interface IEMITEMPLService extends IService<EMITEMPL>{

    boolean update(EMITEMPL et) ;
    void updateBatch(List<EMITEMPL> list) ;
    boolean create(EMITEMPL et) ;
    void createBatch(List<EMITEMPL> list) ;
    boolean save(EMITEMPL et) ;
    void saveBatch(List<EMITEMPL> list) ;
    boolean checkKey(EMITEMPL et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMITEMPL get(String key) ;
    EMITEMPL getDraft(EMITEMPL et) ;
    Page<EMITEMPL> searchDefault(EMITEMPLSearchContext context) ;
    List<EMITEMPL> selectByRid(String emitemrinid) ;
    void removeByRid(String emitemrinid) ;
    List<EMITEMPL> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMITEMPL> selectByStorepartid(String emstorepartid) ;
    void removeByStorepartid(String emstorepartid) ;
    List<EMITEMPL> selectByStoreid(String emstoreid) ;
    void removeByStoreid(String emstoreid) ;
    List<EMITEMPL> selectBySempid(String pfempid) ;
    void removeBySempid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


