package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMITEMPRTN;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMPRTNSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMITEMPRTN] 服务对象接口
 */
public interface IEMITEMPRTNService extends IService<EMITEMPRTN>{

    boolean checkKey(EMITEMPRTN et) ;
    EMITEMPRTN getDraft(EMITEMPRTN et) ;
    boolean update(EMITEMPRTN et) ;
    void updateBatch(List<EMITEMPRTN> list) ;
    EMITEMPRTN get(String key) ;
    boolean save(EMITEMPRTN et) ;
    void saveBatch(List<EMITEMPRTN> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(EMITEMPRTN et) ;
    void createBatch(List<EMITEMPRTN> list) ;
    Page<EMITEMPRTN> searchDefault(EMITEMPRTNSearchContext context) ;
    List<EMITEMPRTN> selectByRid(String emitempuseid) ;
    void removeByRid(String emitempuseid) ;
    List<EMITEMPRTN> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMITEMPRTN> selectByStorepartid(String emstorepartid) ;
    void removeByStorepartid(String emstorepartid) ;
    List<EMITEMPRTN> selectByStoreid(String emstoreid) ;
    void removeByStoreid(String emstoreid) ;
    List<EMITEMPRTN> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    List<EMITEMPRTN> selectBySempid(String pfempid) ;
    void removeBySempid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


