package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMITEMPUSE;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMPUSESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMITEMPUSE] 服务对象接口
 */
public interface IEMITEMPUSEService extends IService<EMITEMPUSE>{

    boolean update(EMITEMPUSE et) ;
    void updateBatch(List<EMITEMPUSE> list) ;
    boolean checkKey(EMITEMPUSE et) ;
    EMITEMPUSE getDraft(EMITEMPUSE et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMITEMPUSE get(String key) ;
    boolean save(EMITEMPUSE et) ;
    void saveBatch(List<EMITEMPUSE> list) ;
    boolean create(EMITEMPUSE et) ;
    void createBatch(List<EMITEMPUSE> list) ;
    Page<EMITEMPUSE> searchDefault(EMITEMPUSESearchContext context) ;
    List<EMITEMPUSE> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMITEMPUSE> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMITEMPUSE> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMITEMPUSE> selectByPurplanid(String empurplanid) ;
    void removeByPurplanid(String empurplanid) ;
    List<EMITEMPUSE> selectByLabserviceid(String emserviceid) ;
    void removeByLabserviceid(String emserviceid) ;
    List<EMITEMPUSE> selectByMserviceid(String emserviceid) ;
    void removeByMserviceid(String emserviceid) ;
    List<EMITEMPUSE> selectByStorepartid(String emstorepartid) ;
    void removeByStorepartid(String emstorepartid) ;
    List<EMITEMPUSE> selectByStoreid(String emstoreid) ;
    void removeByStoreid(String emstoreid) ;
    List<EMITEMPUSE> selectByWoid(String emwoid) ;
    void removeByWoid(String emwoid) ;
    List<EMITEMPUSE> selectByDeptid(String pfdeptid) ;
    void removeByDeptid(String pfdeptid) ;
    List<EMITEMPUSE> selectByAempid(String pfempid) ;
    void removeByAempid(String pfempid) ;
    List<EMITEMPUSE> selectByApprempid(String pfempid) ;
    void removeByApprempid(String pfempid) ;
    List<EMITEMPUSE> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    List<EMITEMPUSE> selectBySempid(String pfempid) ;
    void removeBySempid(String pfempid) ;
    List<EMITEMPUSE> selectByTeamid(String pfteamid) ;
    void removeByTeamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


