package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMITEMRIN;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMRINSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMITEMRIN] 服务对象接口
 */
public interface IEMITEMRINService extends IService<EMITEMRIN>{

    boolean checkKey(EMITEMRIN et) ;
    EMITEMRIN getDraft(EMITEMRIN et) ;
    boolean create(EMITEMRIN et) ;
    void createBatch(List<EMITEMRIN> list) ;
    boolean update(EMITEMRIN et) ;
    void updateBatch(List<EMITEMRIN> list) ;
    boolean save(EMITEMRIN et) ;
    void saveBatch(List<EMITEMRIN> list) ;
    EMITEMRIN get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<EMITEMRIN> searchDefault(EMITEMRINSearchContext context) ;
    List<EMITEMRIN> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMITEMRIN> selectByPodetailid(String empodetailid) ;
    void removeByPodetailid(String empodetailid) ;
    List<EMITEMRIN> selectByEmserviceid(String emserviceid) ;
    void removeByEmserviceid(String emserviceid) ;
    List<EMITEMRIN> selectByStorepartid(String emstorepartid) ;
    void removeByStorepartid(String emstorepartid) ;
    List<EMITEMRIN> selectByStoreid(String emstoreid) ;
    void removeByStoreid(String emstoreid) ;
    List<EMITEMRIN> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    List<EMITEMRIN> selectBySempid(String pfempid) ;
    void removeBySempid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


