package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMITEMROUT;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMROUTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMITEMROUT] 服务对象接口
 */
public interface IEMITEMROUTService extends IService<EMITEMROUT>{

    boolean create(EMITEMROUT et) ;
    void createBatch(List<EMITEMROUT> list) ;
    EMITEMROUT get(String key) ;
    boolean checkKey(EMITEMROUT et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMITEMROUT et) ;
    void updateBatch(List<EMITEMROUT> list) ;
    boolean save(EMITEMROUT et) ;
    void saveBatch(List<EMITEMROUT> list) ;
    EMITEMROUT getDraft(EMITEMROUT et) ;
    Page<EMITEMROUT> searchDefault(EMITEMROUTSearchContext context) ;
    List<EMITEMROUT> selectByRid(String emitemrinid) ;
    void removeByRid(String emitemrinid) ;
    List<EMITEMROUT> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMITEMROUT> selectByStorepartid(String emstorepartid) ;
    void removeByStorepartid(String emstorepartid) ;
    List<EMITEMROUT> selectByStoreid(String emstoreid) ;
    void removeByStoreid(String emstoreid) ;
    List<EMITEMROUT> selectBySempid(String pfempid) ;
    void removeBySempid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


