package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMITEMSUBMAP;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMSUBMAPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMITEMSUBMAP] 服务对象接口
 */
public interface IEMITEMSUBMAPService extends IService<EMITEMSUBMAP>{

    EMITEMSUBMAP get(String key) ;
    boolean save(EMITEMSUBMAP et) ;
    void saveBatch(List<EMITEMSUBMAP> list) ;
    boolean checkKey(EMITEMSUBMAP et) ;
    boolean create(EMITEMSUBMAP et) ;
    void createBatch(List<EMITEMSUBMAP> list) ;
    boolean update(EMITEMSUBMAP et) ;
    void updateBatch(List<EMITEMSUBMAP> list) ;
    EMITEMSUBMAP getDraft(EMITEMSUBMAP et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<EMITEMSUBMAP> searchDefault(EMITEMSUBMAPSearchContext context) ;
    List<EMITEMSUBMAP> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMITEMSUBMAP> selectBySubitemid(String emitemid) ;
    void removeBySubitemid(String emitemid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


