package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMITEM;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMITEM] 服务对象接口
 */
public interface IEMITEMService extends IService<EMITEM>{

    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMITEM get(String key) ;
    boolean save(EMITEM et) ;
    void saveBatch(List<EMITEM> list) ;
    EMITEM getDraft(EMITEM et) ;
    boolean update(EMITEM et) ;
    void updateBatch(List<EMITEM> list) ;
    boolean create(EMITEM et) ;
    void createBatch(List<EMITEM> list) ;
    boolean checkKey(EMITEM et) ;
    Page<EMITEM> searchDefault(EMITEMSearchContext context) ;
    List<EMITEM> selectByAcclassid(String emacclassid) ;
    void removeByAcclassid(String emacclassid) ;
    List<EMITEM> selectByEmcabid(String emcabid) ;
    void removeByEmcabid(String emcabid) ;
    List<EMITEM> selectByItemtypeid(String emitemtypeid) ;
    void removeByItemtypeid(String emitemtypeid) ;
    List<EMITEM> selectByLabserviceid(String emserviceid) ;
    void removeByLabserviceid(String emserviceid) ;
    List<EMITEM> selectByMserviceid(String emserviceid) ;
    void removeByMserviceid(String emserviceid) ;
    List<EMITEM> selectByStorepartid(String emstorepartid) ;
    void removeByStorepartid(String emstorepartid) ;
    List<EMITEM> selectByStoreid(String emstoreid) ;
    void removeByStoreid(String emstoreid) ;
    List<EMITEM> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    List<EMITEM> selectByLastaempid(String pfempid) ;
    void removeByLastaempid(String pfempid) ;
    List<EMITEM> selectBySempid(String pfempid) ;
    void removeBySempid(String pfempid) ;
    List<EMITEM> selectByUnitid(String pfunitid) ;
    void removeByUnitid(String pfunitid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


