package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMITEMTRADE;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMTRADESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMITEMTRADE] 服务对象接口
 */
public interface IEMITEMTRADEService extends IService<EMITEMTRADE>{

    boolean update(EMITEMTRADE et) ;
    void updateBatch(List<EMITEMTRADE> list) ;
    boolean checkKey(EMITEMTRADE et) ;
    boolean create(EMITEMTRADE et) ;
    void createBatch(List<EMITEMTRADE> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(EMITEMTRADE et) ;
    void saveBatch(List<EMITEMTRADE> list) ;
    EMITEMTRADE getDraft(EMITEMTRADE et) ;
    EMITEMTRADE get(String key) ;
    Page<EMITEMTRADE> searchDefault(EMITEMTRADESearchContext context) ;
    Page<EMITEMTRADE> searchIndexDER(EMITEMTRADESearchContext context) ;
    List<EMITEMTRADE> selectByRid(String emitemtradeid) ;
    void removeByRid(String emitemtradeid) ;
    List<EMITEMTRADE> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMITEMTRADE> selectByLabserviceid(String emserviceid) ;
    void removeByLabserviceid(String emserviceid) ;
    List<EMITEMTRADE> selectByStorepartid(String emstorepartid) ;
    void removeByStorepartid(String emstorepartid) ;
    List<EMITEMTRADE> selectByStoreid(String emstoreid) ;
    void removeByStoreid(String emstoreid) ;
    List<EMITEMTRADE> selectByDeptid(String pfdeptid) ;
    void removeByDeptid(String pfdeptid) ;
    List<EMITEMTRADE> selectByAempid(String pfempid) ;
    void removeByAempid(String pfempid) ;
    List<EMITEMTRADE> selectBySempid(String pfempid) ;
    void removeBySempid(String pfempid) ;
    List<EMITEMTRADE> selectByTeamid(String pfteamid) ;
    void removeByTeamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


