package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMITEMTYPE;
import cn.ibizlab.eam.core.eam_core.filter.EMITEMTYPESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMITEMTYPE] 服务对象接口
 */
public interface IEMITEMTYPEService extends IService<EMITEMTYPE>{

    EMITEMTYPE getDraft(EMITEMTYPE et) ;
    EMITEMTYPE get(String key) ;
    boolean save(EMITEMTYPE et) ;
    void saveBatch(List<EMITEMTYPE> list) ;
    boolean checkKey(EMITEMTYPE et) ;
    boolean create(EMITEMTYPE et) ;
    void createBatch(List<EMITEMTYPE> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMITEMTYPE et) ;
    void updateBatch(List<EMITEMTYPE> list) ;
    Page<EMITEMTYPE> searchItemType(EMITEMTYPESearchContext context) ;
    Page<EMITEMTYPE> searchDefault(EMITEMTYPESearchContext context) ;
    List<EMITEMTYPE> selectByItembtypeid(String emitemtypeid) ;
    void removeByItembtypeid(String emitemtypeid) ;
    List<EMITEMTYPE> selectByItemmtypeid(String emitemtypeid) ;
    void removeByItemmtypeid(String emitemtypeid) ;
    List<EMITEMTYPE> selectByItemtypepid(String emitemtypeid) ;
    void removeByItemtypepid(String emitemtypeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


