package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMMACHINECATEGORY;
import cn.ibizlab.eam.core.eam_core.filter.EMMACHINECATEGORYSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMMACHINECATEGORY] 服务对象接口
 */
public interface IEMMACHINECATEGORYService extends IService<EMMACHINECATEGORY>{

    boolean checkKey(EMMACHINECATEGORY et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMMACHINECATEGORY get(String key) ;
    boolean update(EMMACHINECATEGORY et) ;
    void updateBatch(List<EMMACHINECATEGORY> list) ;
    boolean create(EMMACHINECATEGORY et) ;
    void createBatch(List<EMMACHINECATEGORY> list) ;
    EMMACHINECATEGORY getDraft(EMMACHINECATEGORY et) ;
    boolean save(EMMACHINECATEGORY et) ;
    void saveBatch(List<EMMACHINECATEGORY> list) ;
    Page<EMMACHINECATEGORY> searchDefault(EMMACHINECATEGORYSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


