package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMMONTHLYDETAIL;
import cn.ibizlab.eam.core.eam_core.filter.EMMONTHLYDETAILSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMMONTHLYDETAIL] 服务对象接口
 */
public interface IEMMONTHLYDETAILService extends IService<EMMONTHLYDETAIL>{

    EMMONTHLYDETAIL getDraft(EMMONTHLYDETAIL et) ;
    boolean update(EMMONTHLYDETAIL et) ;
    void updateBatch(List<EMMONTHLYDETAIL> list) ;
    boolean checkKey(EMMONTHLYDETAIL et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMMONTHLYDETAIL get(String key) ;
    boolean save(EMMONTHLYDETAIL et) ;
    void saveBatch(List<EMMONTHLYDETAIL> list) ;
    boolean create(EMMONTHLYDETAIL et) ;
    void createBatch(List<EMMONTHLYDETAIL> list) ;
    Page<EMMONTHLYDETAIL> searchDefault(EMMONTHLYDETAILSearchContext context) ;
    List<EMMONTHLYDETAIL> selectByEmmonthlyid(String emmonthlyid) ;
    void removeByEmmonthlyid(String emmonthlyid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


