package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMMONTHLY;
import cn.ibizlab.eam.core.eam_core.filter.EMMONTHLYSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMMONTHLY] 服务对象接口
 */
public interface IEMMONTHLYService extends IService<EMMONTHLY>{

    boolean create(EMMONTHLY et) ;
    void createBatch(List<EMMONTHLY> list) ;
    boolean save(EMMONTHLY et) ;
    void saveBatch(List<EMMONTHLY> list) ;
    boolean checkKey(EMMONTHLY et) ;
    EMMONTHLY get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMMONTHLY et) ;
    void updateBatch(List<EMMONTHLY> list) ;
    EMMONTHLY getDraft(EMMONTHLY et) ;
    Page<EMMONTHLY> searchDefault(EMMONTHLYSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


