package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMOBJECT;
import cn.ibizlab.eam.core.eam_core.filter.EMOBJECTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMOBJECT] 服务对象接口
 */
public interface IEMOBJECTService extends IService<EMOBJECT>{

    boolean save(EMOBJECT et) ;
    void saveBatch(List<EMOBJECT> list) ;
    boolean checkKey(EMOBJECT et) ;
    EMOBJECT get(String key) ;
    EMOBJECT getDraft(EMOBJECT et) ;
    boolean create(EMOBJECT et) ;
    void createBatch(List<EMOBJECT> list) ;
    boolean update(EMOBJECT et) ;
    void updateBatch(List<EMOBJECT> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<EMOBJECT> searchDefault(EMOBJECTSearchContext context) ;
    Page<EMOBJECT> searchIndexDER(EMOBJECTSearchContext context) ;
    List<EMOBJECT> selectByMajorequipid(String emequipid) ;
    void removeByMajorequipid(String emequipid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


