package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMOBJMAP;
import cn.ibizlab.eam.core.eam_core.filter.EMOBJMAPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMOBJMAP] 服务对象接口
 */
public interface IEMOBJMAPService extends IService<EMOBJMAP>{

    boolean update(EMOBJMAP et) ;
    void updateBatch(List<EMOBJMAP> list) ;
    boolean create(EMOBJMAP et) ;
    void createBatch(List<EMOBJMAP> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(EMOBJMAP et) ;
    void saveBatch(List<EMOBJMAP> list) ;
    boolean checkKey(EMOBJMAP et) ;
    EMOBJMAP getDraft(EMOBJMAP et) ;
    EMOBJMAP get(String key) ;
    Page<EMOBJMAP> searchDefault(EMOBJMAPSearchContext context) ;
    Page<EMOBJMAP> searchIndexDER(EMOBJMAPSearchContext context) ;
    List<EMOBJMAP> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMOBJMAP> selectByObjpid(String emobjectid) ;
    void removeByObjpid(String emobjectid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


