package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMOUTPUTRCT;
import cn.ibizlab.eam.core.eam_core.filter.EMOUTPUTRCTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMOUTPUTRCT] 服务对象接口
 */
public interface IEMOUTPUTRCTService extends IService<EMOUTPUTRCT>{

    EMOUTPUTRCT get(String key) ;
    boolean create(EMOUTPUTRCT et) ;
    void createBatch(List<EMOUTPUTRCT> list) ;
    boolean save(EMOUTPUTRCT et) ;
    void saveBatch(List<EMOUTPUTRCT> list) ;
    EMOUTPUTRCT getDraft(EMOUTPUTRCT et) ;
    boolean update(EMOUTPUTRCT et) ;
    void updateBatch(List<EMOUTPUTRCT> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMOUTPUTRCT et) ;
    Page<EMOUTPUTRCT> searchDefault(EMOUTPUTRCTSearchContext context) ;
    List<EMOUTPUTRCT> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMOUTPUTRCT> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMOUTPUTRCT> selectByOutputid(String emoutputid) ;
    void removeByOutputid(String emoutputid) ;
    List<EMOUTPUTRCT> selectByWoid(String emwoid) ;
    void removeByWoid(String emwoid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


