package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMPLANDETAIL;
import cn.ibizlab.eam.core.eam_core.filter.EMPLANDETAILSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMPLANDETAIL] 服务对象接口
 */
public interface IEMPLANDETAILService extends IService<EMPLANDETAIL>{

    EMPLANDETAIL get(String key) ;
    EMPLANDETAIL getDraft(EMPLANDETAIL et) ;
    boolean save(EMPLANDETAIL et) ;
    void saveBatch(List<EMPLANDETAIL> list) ;
    boolean update(EMPLANDETAIL et) ;
    void updateBatch(List<EMPLANDETAIL> list) ;
    boolean create(EMPLANDETAIL et) ;
    void createBatch(List<EMPLANDETAIL> list) ;
    boolean checkKey(EMPLANDETAIL et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<EMPLANDETAIL> searchDefault(EMPLANDETAILSearchContext context) ;
    List<EMPLANDETAIL> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMPLANDETAIL> selectByDpid(String emobjectid) ;
    void removeByDpid(String emobjectid) ;
    List<EMPLANDETAIL> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMPLANDETAIL> selectByPlanid(String emplanid) ;
    void removeByPlanid(String emplanid) ;
    List<EMPLANDETAIL> selectByRecvpersonid(String pfempid) ;
    void removeByRecvpersonid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


