package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMPLAN;
import cn.ibizlab.eam.core.eam_core.filter.EMPLANSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMPLAN] 服务对象接口
 */
public interface IEMPLANService extends IService<EMPLAN>{

    boolean create(EMPLAN et) ;
    void createBatch(List<EMPLAN> list) ;
    boolean update(EMPLAN et) ;
    void updateBatch(List<EMPLAN> list) ;
    EMPLAN get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMPLAN getDraft(EMPLAN et) ;
    boolean checkKey(EMPLAN et) ;
    boolean save(EMPLAN et) ;
    void saveBatch(List<EMPLAN> list) ;
    Page<EMPLAN> searchDefault(EMPLANSearchContext context) ;
    List<EMPLAN> selectByAcclassid(String emacclassid) ;
    void removeByAcclassid(String emacclassid) ;
    List<EMPLAN> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMPLAN> selectByDpid(String emobjectid) ;
    void removeByDpid(String emobjectid) ;
    List<EMPLAN> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMPLAN> selectByPlantemplid(String emplantemplid) ;
    void removeByPlantemplid(String emplantemplid) ;
    List<EMPLAN> selectByRserviceid(String emserviceid) ;
    void removeByRserviceid(String emserviceid) ;
    List<EMPLAN> selectByRdeptid(String pfdeptid) ;
    void removeByRdeptid(String pfdeptid) ;
    List<EMPLAN> selectByMpersonid(String pfempid) ;
    void removeByMpersonid(String pfempid) ;
    List<EMPLAN> selectByRecvpersonid(String pfempid) ;
    void removeByRecvpersonid(String pfempid) ;
    List<EMPLAN> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMPLAN> selectByRteamid(String pfteamid) ;
    void removeByRteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


