package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMPLANTDETAIL;
import cn.ibizlab.eam.core.eam_core.filter.EMPLANTDETAILSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMPLANTDETAIL] 服务对象接口
 */
public interface IEMPLANTDETAILService extends IService<EMPLANTDETAIL>{

    boolean update(EMPLANTDETAIL et) ;
    void updateBatch(List<EMPLANTDETAIL> list) ;
    EMPLANTDETAIL getDraft(EMPLANTDETAIL et) ;
    boolean create(EMPLANTDETAIL et) ;
    void createBatch(List<EMPLANTDETAIL> list) ;
    boolean save(EMPLANTDETAIL et) ;
    void saveBatch(List<EMPLANTDETAIL> list) ;
    EMPLANTDETAIL get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMPLANTDETAIL et) ;
    Page<EMPLANTDETAIL> searchDefault(EMPLANTDETAILSearchContext context) ;
    List<EMPLANTDETAIL> selectByPlantemplid(String emplantemplid) ;
    void removeByPlantemplid(String emplantemplid) ;
    List<EMPLANTDETAIL> selectByRecvpersonid(String pfempid) ;
    void removeByRecvpersonid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


