package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMPODETAIL;
import cn.ibizlab.eam.core.eam_core.filter.EMPODETAILSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMPODETAIL] 服务对象接口
 */
public interface IEMPODETAILService extends IService<EMPODETAIL>{

    boolean update(EMPODETAIL et) ;
    void updateBatch(List<EMPODETAIL> list) ;
    EMPODETAIL get(String key) ;
    boolean create(EMPODETAIL et) ;
    void createBatch(List<EMPODETAIL> list) ;
    EMPODETAIL getDraft(EMPODETAIL et) ;
    boolean save(EMPODETAIL et) ;
    void saveBatch(List<EMPODETAIL> list) ;
    boolean checkKey(EMPODETAIL et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<HashMap> searchLaterYear(EMPODETAILSearchContext context) ;
    Page<EMPODETAIL> searchDefault(EMPODETAILSearchContext context) ;
    List<EMPODETAIL> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMPODETAIL> selectByPoid(String empoid) ;
    void removeByPoid(String empoid) ;
    List<EMPODETAIL> selectByWplistid(String emwplistid) ;
    void removeByWplistid(String emwplistid) ;
    List<EMPODETAIL> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    List<EMPODETAIL> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMPODETAIL> selectByRunitid(String pfunitid) ;
    void removeByRunitid(String pfunitid) ;
    List<EMPODETAIL> selectByUnitid(String pfunitid) ;
    void removeByUnitid(String pfunitid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


