package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMPRODUCT;
import cn.ibizlab.eam.core.eam_core.filter.EMPRODUCTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMPRODUCT] 服务对象接口
 */
public interface IEMPRODUCTService extends IService<EMPRODUCT>{

    EMPRODUCT getDraft(EMPRODUCT et) ;
    boolean create(EMPRODUCT et) ;
    void createBatch(List<EMPRODUCT> list) ;
    boolean save(EMPRODUCT et) ;
    void saveBatch(List<EMPRODUCT> list) ;
    boolean checkKey(EMPRODUCT et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMPRODUCT et) ;
    void updateBatch(List<EMPRODUCT> list) ;
    EMPRODUCT get(String key) ;
    Page<EMPRODUCT> searchDefault(EMPRODUCTSearchContext context) ;
    List<EMPRODUCT> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMPRODUCT> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMPRODUCT> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMPRODUCT> selectByServiceid(String emserviceid) ;
    void removeByServiceid(String emserviceid) ;
    List<EMPRODUCT> selectByDeptid(String pfdeptid) ;
    void removeByDeptid(String pfdeptid) ;
    List<EMPRODUCT> selectByAempid(String pfempid) ;
    void removeByAempid(String pfempid) ;
    List<EMPRODUCT> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    List<EMPRODUCT> selectByTeamid(String pfteamid) ;
    void removeByTeamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


