package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMPROJECTTRACK;
import cn.ibizlab.eam.core.eam_core.filter.EMPROJECTTRACKSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMPROJECTTRACK] 服务对象接口
 */
public interface IEMPROJECTTRACKService extends IService<EMPROJECTTRACK>{

    boolean save(EMPROJECTTRACK et) ;
    void saveBatch(List<EMPROJECTTRACK> list) ;
    boolean checkKey(EMPROJECTTRACK et) ;
    EMPROJECTTRACK get(String key) ;
    boolean create(EMPROJECTTRACK et) ;
    void createBatch(List<EMPROJECTTRACK> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMPROJECTTRACK et) ;
    void updateBatch(List<EMPROJECTTRACK> list) ;
    EMPROJECTTRACK getDraft(EMPROJECTTRACK et) ;
    Page<EMPROJECTTRACK> searchDefault(EMPROJECTTRACKSearchContext context) ;
    List<EMPROJECTTRACK> selectByEmpurplanid(String empurplanid) ;
    void removeByEmpurplanid(String empurplanid) ;
    List<EMPROJECTTRACK> selectByEmserviceid(String emserviceid) ;
    void removeByEmserviceid(String emserviceid) ;
    List<EMPROJECTTRACK> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


