package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMPURCHANGEHIS;
import cn.ibizlab.eam.core.eam_core.filter.EMPURCHANGEHISSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMPURCHANGEHIS] 服务对象接口
 */
public interface IEMPURCHANGEHISService extends IService<EMPURCHANGEHIS>{

    EMPURCHANGEHIS getDraft(EMPURCHANGEHIS et) ;
    boolean update(EMPURCHANGEHIS et) ;
    void updateBatch(List<EMPURCHANGEHIS> list) ;
    boolean save(EMPURCHANGEHIS et) ;
    void saveBatch(List<EMPURCHANGEHIS> list) ;
    EMPURCHANGEHIS get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMPURCHANGEHIS et) ;
    boolean create(EMPURCHANGEHIS et) ;
    void createBatch(List<EMPURCHANGEHIS> list) ;
    Page<EMPURCHANGEHIS> searchDefault(EMPURCHANGEHISSearchContext context) ;
    List<EMPURCHANGEHIS> selectByEmitempuseid(String emitempuseid) ;
    void removeByEmitempuseid(String emitempuseid) ;
    List<EMPURCHANGEHIS> selectByPfdeptid(String pfdeptid) ;
    void removeByPfdeptid(String pfdeptid) ;
    List<EMPURCHANGEHIS> selectByPfempid(String pfempid) ;
    void removeByPfempid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


