package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMPURPLAN;
import cn.ibizlab.eam.core.eam_core.filter.EMPURPLANSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMPURPLAN] 服务对象接口
 */
public interface IEMPURPLANService extends IService<EMPURPLAN>{

    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMPURPLAN et) ;
    void updateBatch(List<EMPURPLAN> list) ;
    boolean create(EMPURPLAN et) ;
    void createBatch(List<EMPURPLAN> list) ;
    boolean save(EMPURPLAN et) ;
    void saveBatch(List<EMPURPLAN> list) ;
    EMPURPLAN get(String key) ;
    EMPURPLAN getDraft(EMPURPLAN et) ;
    boolean checkKey(EMPURPLAN et) ;
    Page<EMPURPLAN> searchDefault(EMPURPLANSearchContext context) ;
    List<EMPURPLAN> selectByEmbidinquiryid(String embidinquiryid) ;
    void removeByEmbidinquiryid(String embidinquiryid) ;
    List<EMPURPLAN> selectByItemtypeid(String emitemtypeid) ;
    void removeByItemtypeid(String emitemtypeid) ;
    List<EMPURPLAN> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMPURPLAN> selectByUnitid(String pfunitid) ;
    void removeByUnitid(String pfunitid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


