package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMREPAIRCOST;
import cn.ibizlab.eam.core.eam_core.filter.EMREPAIRCOSTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMREPAIRCOST] 服务对象接口
 */
public interface IEMREPAIRCOSTService extends IService<EMREPAIRCOST>{

    boolean checkKey(EMREPAIRCOST et) ;
    boolean update(EMREPAIRCOST et) ;
    void updateBatch(List<EMREPAIRCOST> list) ;
    boolean create(EMREPAIRCOST et) ;
    void createBatch(List<EMREPAIRCOST> list) ;
    boolean save(EMREPAIRCOST et) ;
    void saveBatch(List<EMREPAIRCOST> list) ;
    EMREPAIRCOST getDraft(EMREPAIRCOST et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMREPAIRCOST get(String key) ;
    Page<EMREPAIRCOST> searchDefault(EMREPAIRCOSTSearchContext context) ;
    List<EMREPAIRCOST> selectByEmequipid(String emequipid) ;
    void removeByEmequipid(String emequipid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


