package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMRESEMP;
import cn.ibizlab.eam.core.eam_core.filter.EMRESEMPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMRESEMP] 服务对象接口
 */
public interface IEMRESEMPService extends IService<EMRESEMP>{

    EMRESEMP getDraft(EMRESEMP et) ;
    EMRESEMP get(String key) ;
    boolean create(EMRESEMP et) ;
    void createBatch(List<EMRESEMP> list) ;
    boolean update(EMRESEMP et) ;
    void updateBatch(List<EMRESEMP> list) ;
    boolean save(EMRESEMP et) ;
    void saveBatch(List<EMRESEMP> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMRESEMP et) ;
    Page<EMRESEMP> searchDefault(EMRESEMPSearchContext context) ;
    List<EMRESEMP> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMRESEMP> selectByResrefobjid(String emresrefobjid) ;
    void removeByResrefobjid(String emresrefobjid) ;
    List<EMRESEMP> selectByResid(String pfempid) ;
    void removeByResid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


