package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMRESITEM;
import cn.ibizlab.eam.core.eam_core.filter.EMRESITEMSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMRESITEM] 服务对象接口
 */
public interface IEMRESITEMService extends IService<EMRESITEM>{

    boolean save(EMRESITEM et) ;
    void saveBatch(List<EMRESITEM> list) ;
    boolean update(EMRESITEM et) ;
    void updateBatch(List<EMRESITEM> list) ;
    EMRESITEM getDraft(EMRESITEM et) ;
    EMRESITEM get(String key) ;
    boolean checkKey(EMRESITEM et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(EMRESITEM et) ;
    void createBatch(List<EMRESITEM> list) ;
    Page<EMRESITEM> searchDefault(EMRESITEMSearchContext context) ;
    List<EMRESITEM> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMRESITEM> selectByResid(String emitemid) ;
    void removeByResid(String emitemid) ;
    List<EMRESITEM> selectByResrefobjid(String emresrefobjid) ;
    void removeByResrefobjid(String emresrefobjid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


