package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMRESREFOBJ;
import cn.ibizlab.eam.core.eam_core.filter.EMRESREFOBJSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMRESREFOBJ] 服务对象接口
 */
public interface IEMRESREFOBJService extends IService<EMRESREFOBJ>{

    EMRESREFOBJ getDraft(EMRESREFOBJ et) ;
    EMRESREFOBJ get(String key) ;
    boolean update(EMRESREFOBJ et) ;
    void updateBatch(List<EMRESREFOBJ> list) ;
    boolean save(EMRESREFOBJ et) ;
    void saveBatch(List<EMRESREFOBJ> list) ;
    boolean checkKey(EMRESREFOBJ et) ;
    boolean create(EMRESREFOBJ et) ;
    void createBatch(List<EMRESREFOBJ> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<EMRESREFOBJ> searchIndexDER(EMRESREFOBJSearchContext context) ;
    Page<EMRESREFOBJ> searchDefault(EMRESREFOBJSearchContext context) ;
    List<EMRESREFOBJ> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMRESREFOBJ> selectByResrefobjpid(String emresrefobjid) ;
    void removeByResrefobjpid(String emresrefobjid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


