package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMRESSERVICE;
import cn.ibizlab.eam.core.eam_core.filter.EMRESSERVICESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMRESSERVICE] 服务对象接口
 */
public interface IEMRESSERVICEService extends IService<EMRESSERVICE>{

    boolean checkKey(EMRESSERVICE et) ;
    EMRESSERVICE get(String key) ;
    boolean save(EMRESSERVICE et) ;
    void saveBatch(List<EMRESSERVICE> list) ;
    boolean create(EMRESSERVICE et) ;
    void createBatch(List<EMRESSERVICE> list) ;
    boolean update(EMRESSERVICE et) ;
    void updateBatch(List<EMRESSERVICE> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMRESSERVICE getDraft(EMRESSERVICE et) ;
    Page<EMRESSERVICE> searchDefault(EMRESSERVICESearchContext context) ;
    List<EMRESSERVICE> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMRESSERVICE> selectByResrefobjid(String emresrefobjid) ;
    void removeByResrefobjid(String emresrefobjid) ;
    List<EMRESSERVICE> selectByResid(String emserviceid) ;
    void removeByResid(String emserviceid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


