package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMRFODEMAP;
import cn.ibizlab.eam.core.eam_core.filter.EMRFODEMAPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMRFODEMAP] 服务对象接口
 */
public interface IEMRFODEMAPService extends IService<EMRFODEMAP>{

    boolean save(EMRFODEMAP et) ;
    void saveBatch(List<EMRFODEMAP> list) ;
    EMRFODEMAP get(String key) ;
    boolean update(EMRFODEMAP et) ;
    void updateBatch(List<EMRFODEMAP> list) ;
    boolean create(EMRFODEMAP et) ;
    void createBatch(List<EMRFODEMAP> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMRFODEMAP getDraft(EMRFODEMAP et) ;
    boolean checkKey(EMRFODEMAP et) ;
    Page<EMRFODEMAP> searchDefault(EMRFODEMAPSearchContext context) ;
    List<EMRFODEMAP> selectByRefobjid(String emobjectid) ;
    void removeByRefobjid(String emobjectid) ;
    List<EMRFODEMAP> selectByRfodeid(String emrfodeid) ;
    void removeByRfodeid(String emrfodeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


