package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMRIGGINGH;
import cn.ibizlab.eam.core.eam_core.filter.EMRIGGINGHSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMRIGGINGH] 服务对象接口
 */
public interface IEMRIGGINGHService extends IService<EMRIGGINGH>{

    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(EMRIGGINGH et) ;
    void saveBatch(List<EMRIGGINGH> list) ;
    boolean update(EMRIGGINGH et) ;
    void updateBatch(List<EMRIGGINGH> list) ;
    boolean create(EMRIGGINGH et) ;
    void createBatch(List<EMRIGGINGH> list) ;
    EMRIGGINGH get(String key) ;
    EMRIGGINGH getDraft(EMRIGGINGH et) ;
    boolean checkKey(EMRIGGINGH et) ;
    Page<EMRIGGINGH> searchDefault(EMRIGGINGHSearchContext context) ;
    List<EMRIGGINGH> selectByEmitempuseid(String emitempuseid) ;
    void removeByEmitempuseid(String emitempuseid) ;
    List<EMRIGGINGH> selectByEmriggingid(String emriggingid) ;
    void removeByEmriggingid(String emriggingid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


