package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMSERVICEEVL;
import cn.ibizlab.eam.core.eam_core.filter.EMSERVICEEVLSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMSERVICEEVL] 服务对象接口
 */
public interface IEMSERVICEEVLService extends IService<EMSERVICEEVL>{

    boolean checkKey(EMSERVICEEVL et) ;
    EMSERVICEEVL getDraft(EMSERVICEEVL et) ;
    boolean save(EMSERVICEEVL et) ;
    void saveBatch(List<EMSERVICEEVL> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMSERVICEEVL get(String key) ;
    boolean create(EMSERVICEEVL et) ;
    void createBatch(List<EMSERVICEEVL> list) ;
    boolean update(EMSERVICEEVL et) ;
    void updateBatch(List<EMSERVICEEVL> list) ;
    Page<EMSERVICEEVL> searchDefault(EMSERVICEEVLSearchContext context) ;
    List<EMSERVICEEVL> selectByServiceid(String emserviceid) ;
    void removeByServiceid(String emserviceid) ;
    List<EMSERVICEEVL> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


