package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMSERVICEHIST;
import cn.ibizlab.eam.core.eam_core.filter.EMSERVICEHISTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMSERVICEHIST] 服务对象接口
 */
public interface IEMSERVICEHISTService extends IService<EMSERVICEHIST>{

    boolean checkKey(EMSERVICEHIST et) ;
    boolean save(EMSERVICEHIST et) ;
    void saveBatch(List<EMSERVICEHIST> list) ;
    EMSERVICEHIST get(String key) ;
    EMSERVICEHIST getDraft(EMSERVICEHIST et) ;
    boolean create(EMSERVICEHIST et) ;
    void createBatch(List<EMSERVICEHIST> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMSERVICEHIST et) ;
    void updateBatch(List<EMSERVICEHIST> list) ;
    Page<EMSERVICEHIST> searchDefault(EMSERVICEHISTSearchContext context) ;
    List<EMSERVICEHIST> selectByEmserviceid(String emserviceid) ;
    void removeByEmserviceid(String emserviceid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


