package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMSERVICE;
import cn.ibizlab.eam.core.eam_core.filter.EMSERVICESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMSERVICE] 服务对象接口
 */
public interface IEMSERVICEService extends IService<EMSERVICE>{

    EMSERVICE getDraft(EMSERVICE et) ;
    boolean save(EMSERVICE et) ;
    void saveBatch(List<EMSERVICE> list) ;
    boolean create(EMSERVICE et) ;
    void createBatch(List<EMSERVICE> list) ;
    boolean update(EMSERVICE et) ;
    void updateBatch(List<EMSERVICE> list) ;
    EMSERVICE get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMSERVICE et) ;
    Page<EMSERVICE> searchDefault(EMSERVICESearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


