package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMSTOCK;
import cn.ibizlab.eam.core.eam_core.filter.EMSTOCKSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMSTOCK] 服务对象接口
 */
public interface IEMSTOCKService extends IService<EMSTOCK>{

    boolean checkKey(EMSTOCK et) ;
    boolean update(EMSTOCK et) ;
    void updateBatch(List<EMSTOCK> list) ;
    boolean save(EMSTOCK et) ;
    void saveBatch(List<EMSTOCK> list) ;
    boolean create(EMSTOCK et) ;
    void createBatch(List<EMSTOCK> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMSTOCK getDraft(EMSTOCK et) ;
    EMSTOCK get(String key) ;
    Page<EMSTOCK> searchDefault(EMSTOCKSearchContext context) ;
    Page<HashMap> searchTypeStock(EMSTOCKSearchContext context) ;
    List<EMSTOCK> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMSTOCK> selectByStorepartid(String emstorepartid) ;
    void removeByStorepartid(String emstorepartid) ;
    List<EMSTOCK> selectByStoreid(String emstoreid) ;
    void removeByStoreid(String emstoreid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


