package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMSTOREPART;
import cn.ibizlab.eam.core.eam_core.filter.EMSTOREPARTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMSTOREPART] 服务对象接口
 */
public interface IEMSTOREPARTService extends IService<EMSTOREPART>{

    boolean update(EMSTOREPART et) ;
    void updateBatch(List<EMSTOREPART> list) ;
    EMSTOREPART getDraft(EMSTOREPART et) ;
    boolean save(EMSTOREPART et) ;
    void saveBatch(List<EMSTOREPART> list) ;
    boolean create(EMSTOREPART et) ;
    void createBatch(List<EMSTOREPART> list) ;
    EMSTOREPART get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMSTOREPART et) ;
    Page<EMSTOREPART> searchDefault(EMSTOREPARTSearchContext context) ;
    List<EMSTOREPART> selectByStoreid(String emstoreid) ;
    void removeByStoreid(String emstoreid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


