package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMSTORE;
import cn.ibizlab.eam.core.eam_core.filter.EMSTORESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMSTORE] 服务对象接口
 */
public interface IEMSTOREService extends IService<EMSTORE>{

    boolean update(EMSTORE et) ;
    void updateBatch(List<EMSTORE> list) ;
    EMSTORE getDraft(EMSTORE et) ;
    boolean checkKey(EMSTORE et) ;
    EMSTORE get(String key) ;
    boolean create(EMSTORE et) ;
    void createBatch(List<EMSTORE> list) ;
    boolean save(EMSTORE et) ;
    void saveBatch(List<EMSTORE> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<EMSTORE> searchDefault(EMSTORESearchContext context) ;
    List<EMSTORE> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


