package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMSUBLIST;
import cn.ibizlab.eam.core.eam_core.filter.EMSUBLISTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMSUBLIST] 服务对象接口
 */
public interface IEMSUBLISTService extends IService<EMSUBLIST>{

    boolean checkKey(EMSUBLIST et) ;
    EMSUBLIST get(String key) ;
    boolean save(EMSUBLIST et) ;
    void saveBatch(List<EMSUBLIST> list) ;
    boolean create(EMSUBLIST et) ;
    void createBatch(List<EMSUBLIST> list) ;
    EMSUBLIST getDraft(EMSUBLIST et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMSUBLIST et) ;
    void updateBatch(List<EMSUBLIST> list) ;
    Page<EMSUBLIST> searchDefault(EMSUBLISTSearchContext context) ;
    List<EMSUBLIST> selectByPfteamid(String pfteamid) ;
    void removeByPfteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


