package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMSYSCTRL;
import cn.ibizlab.eam.core.eam_core.filter.EMSYSCTRLSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMSYSCTRL] 服务对象接口
 */
public interface IEMSYSCTRLService extends IService<EMSYSCTRL>{

    boolean create(EMSYSCTRL et) ;
    void createBatch(List<EMSYSCTRL> list) ;
    boolean update(EMSYSCTRL et) ;
    void updateBatch(List<EMSYSCTRL> list) ;
    EMSYSCTRL get(String key) ;
    boolean save(EMSYSCTRL et) ;
    void saveBatch(List<EMSYSCTRL> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMSYSCTRL getDraft(EMSYSCTRL et) ;
    boolean checkKey(EMSYSCTRL et) ;
    Page<EMSYSCTRL> searchDefault(EMSYSCTRLSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


