package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMWEEKLYPLAN;
import cn.ibizlab.eam.core.eam_core.filter.EMWEEKLYPLANSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMWEEKLYPLAN] 服务对象接口
 */
public interface IEMWEEKLYPLANService extends IService<EMWEEKLYPLAN>{

    boolean create(EMWEEKLYPLAN et) ;
    void createBatch(List<EMWEEKLYPLAN> list) ;
    EMWEEKLYPLAN get(String key) ;
    boolean save(EMWEEKLYPLAN et) ;
    void saveBatch(List<EMWEEKLYPLAN> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMWEEKLYPLAN et) ;
    void updateBatch(List<EMWEEKLYPLAN> list) ;
    EMWEEKLYPLAN getDraft(EMWEEKLYPLAN et) ;
    boolean checkKey(EMWEEKLYPLAN et) ;
    Page<EMWEEKLYPLAN> searchDefault(EMWEEKLYPLANSearchContext context) ;
    List<EMWEEKLYPLAN> selectByPfteamid(String pfteamid) ;
    void removeByPfteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


