package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMWPLISTCOST;
import cn.ibizlab.eam.core.eam_core.filter.EMWPLISTCOSTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMWPLISTCOST] 服务对象接口
 */
public interface IEMWPLISTCOSTService extends IService<EMWPLISTCOST>{

    boolean update(EMWPLISTCOST et) ;
    void updateBatch(List<EMWPLISTCOST> list) ;
    boolean create(EMWPLISTCOST et) ;
    void createBatch(List<EMWPLISTCOST> list) ;
    EMWPLISTCOST getDraft(EMWPLISTCOST et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMWPLISTCOST get(String key) ;
    boolean save(EMWPLISTCOST et) ;
    void saveBatch(List<EMWPLISTCOST> list) ;
    boolean checkKey(EMWPLISTCOST et) ;
    Page<EMWPLISTCOST> searchDefault(EMWPLISTCOSTSearchContext context) ;
    List<EMWPLISTCOST> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMWPLISTCOST> selectByLabserviceid(String emserviceid) ;
    void removeByLabserviceid(String emserviceid) ;
    List<EMWPLISTCOST> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMWPLISTCOST> selectByUnitid(String pfunitid) ;
    void removeByUnitid(String pfunitid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


