package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_core.domain.EMWPLIST;
import cn.ibizlab.eam.core.eam_core.filter.EMWPLISTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMWPLIST] 服务对象接口
 */
public interface IEMWPLISTService extends IService<EMWPLIST>{

    boolean create(EMWPLIST et) ;
    void createBatch(List<EMWPLIST> list) ;
    EMWPLIST get(String key) ;
    EMWPLIST getDraft(EMWPLIST et) ;
    boolean save(EMWPLIST et) ;
    void saveBatch(List<EMWPLIST> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(EMWPLIST et) ;
    void updateBatch(List<EMWPLIST> list) ;
    boolean checkKey(EMWPLIST et) ;
    Page<EMWPLIST> searchDefault(EMWPLISTSearchContext context) ;
    Page<EMWPLIST> searchMain6_8692(EMWPLISTSearchContext context) ;
    List<EMWPLIST> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMWPLIST> selectByItemid(String emitemid) ;
    void removeByItemid(String emitemid) ;
    List<EMWPLIST> selectByObjid(String emobjectid) ;
    void removeByObjid(String emobjectid) ;
    List<EMWPLIST> selectByEmserviceid(String emserviceid) ;
    void removeByEmserviceid(String emserviceid) ;
    List<EMWPLIST> selectByWplistcostid(String emwplistcostid) ;
    void removeByWplistcostid(String emwplistcostid) ;
    List<EMWPLIST> selectByDeptid(String pfdeptid) ;
    void removeByDeptid(String pfdeptid) ;
    List<EMWPLIST> selectByAempid(String pfempid) ;
    void removeByAempid(String pfempid) ;
    List<EMWPLIST> selectByApprempid(String pfempid) ;
    void removeByApprempid(String pfempid) ;
    List<EMWPLIST> selectByRempid(String pfempid) ;
    void removeByRempid(String pfempid) ;
    List<EMWPLIST> selectByTeamid(String pfteamid) ;
    void removeByTeamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


