package cn.ibizlab.eam.core.eam_core.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.eam.core.eam_core.domain.EMEQUIP;
import cn.ibizlab.eam.core.eam_core.filter.EMEQUIPSearchContext;
import cn.ibizlab.eam.core.eam_core.service.IEMEQUIPService;

import cn.ibizlab.eam.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.eam.core.eam_core.mapper.EMEQUIPMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[设备档案] 服务对象接口实现
 */
@Slf4j
@Service("EMEQUIPServiceImpl")
public class EMEQUIPServiceImpl extends ServiceImpl<EMEQUIPMapper, EMEQUIP> implements IEMEQUIPService {

    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMAPPLYService emapplyService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMASSESSMXService emassessmxService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMDPRCTService emdprctService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEIBATTERYSETUPService emeibatterysetupService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEIBATTERYService emeibatteryService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICAMSETUPService emeicamsetupService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICAMService emeicamService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICELLSETUPService emeicellsetupService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICELLService emeicellService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEITIRESService emeitiresService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEITOOLService emeitoolService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMENCONSUMService emenconsumService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQAHService emeqahService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQCHECKService emeqcheckService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQDEBUGService emeqdebugService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQKEEPService emeqkeepService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQKPRCDService emeqkprcdService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQLCTFDJService emeqlctfdjService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQLCTGSSService emeqlctgssService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQLCTRHYService emeqlctrhyService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQLCTTIRESService emeqlcttiresService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQLOCATIONService emeqlocationService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQMAINTANCEService emeqmaintanceService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQMONITORService emeqmonitorService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQMPMTRService emeqmpmtrService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQMPService emeqmpService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQSETUPService emeqsetupService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQSTOPMONIService emeqstopmoniService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQSTOPService emeqstopService;

    private cn.ibizlab.eam.core.eam_core.service.IEMEQUIPService emequipService = this;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQWLService emeqwlService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMPUSEService emitempuseService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMJYJLService emjyjlService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMOBJECTService emobjectService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMOUTPUTRCTService emoutputrctService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPLANCDTService emplancdtService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPLANDETAILService emplandetailService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPLANService emplanService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPRODUCTService emproductService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMREPAIRCOSTService emrepaircostService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMRESEMPService emresempService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMRESITEMService emresitemService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMRESREFOBJService emresrefobjService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMRESSERVICEService emresserviceService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_DPService emwoDpService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWOService emwoService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_ENService emwoEnService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_INNERService emwoInnerService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_OSCService emwoOscService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_PTService emwoPtService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWPLISTService emwplistService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMACCLASSService emacclassService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMASSETService emassetService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMBERTHService emberthService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMBRANDService embrandService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQTYPEService emeqtypeService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMMACHINECATEGORYService emmachinecategoryService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMMACHMODELService emmachmodelService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMSERVICEService emserviceService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFCONTRACTService pfcontractService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFDEPTService pfdeptService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFEMPService pfempService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFTEAMService pfteamService;

    private int batchSize = 500;

    @Override
    @Transactional
    public boolean update(EMEQUIP et) {
        fillParentData(et);
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("emequipid",et.getEmequipid())))
            return false;
        CachedBeanCopier.copy(get(et.getEmequipid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<EMEQUIP> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean create(EMEQUIP et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getEmequipid()),et);
        return true;
    }

    @Override
    public void createBatch(List<EMEQUIP> list) {
        list.forEach(item->fillParentData(item));
        saveBatch(list,batchSize);
    }

    @Override
    public boolean checkKey(EMEQUIP et) {
        return (!ObjectUtils.isEmpty(et.getEmequipid()))&&(!Objects.isNull(this.getById(et.getEmequipid())));
    }

    @Override
    @Transactional
    public EMEQUIP get(String key) {
        EMEQUIP et = getById(key);
        if(et==null){
            et=new EMEQUIP();
            et.setEmequipid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean save(EMEQUIP et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(EMEQUIP et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<EMEQUIP> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    public EMEQUIP getDraft(EMEQUIP et) {
        fillParentData(et);
        return et;
    }


	@Override
    public List<EMEQUIP> selectByAcclassid(String emacclassid) {
        return baseMapper.selectByAcclassid(emacclassid);
    }

    @Override
    public void removeByAcclassid(String emacclassid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("acclassid",emacclassid));
    }

	@Override
    public List<EMEQUIP> selectByAssetid(String emassetid) {
        return baseMapper.selectByAssetid(emassetid);
    }

    @Override
    public void removeByAssetid(String emassetid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("assetid",emassetid));
    }

	@Override
    public List<EMEQUIP> selectByEmberthid(String emberthid) {
        return baseMapper.selectByEmberthid(emberthid);
    }

    @Override
    public void removeByEmberthid(String emberthid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("emberthid",emberthid));
    }

	@Override
    public List<EMEQUIP> selectByEmbrandid(String embrandid) {
        return baseMapper.selectByEmbrandid(embrandid);
    }

    @Override
    public void removeByEmbrandid(String embrandid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("embrandid",embrandid));
    }

	@Override
    public List<EMEQUIP> selectByEqlocationid(String emeqlocationid) {
        return baseMapper.selectByEqlocationid(emeqlocationid);
    }

    @Override
    public void removeByEqlocationid(String emeqlocationid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("eqlocationid",emeqlocationid));
    }

	@Override
    public List<EMEQUIP> selectByEqtypeid(String emeqtypeid) {
        return baseMapper.selectByEqtypeid(emeqtypeid);
    }

    @Override
    public void removeByEqtypeid(String emeqtypeid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("eqtypeid",emeqtypeid));
    }

	@Override
    public List<EMEQUIP> selectByEquippid(String emequipid) {
        return baseMapper.selectByEquippid(emequipid);
    }

    @Override
    public void removeByEquippid(String emequipid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("equippid",emequipid));
    }

	@Override
    public List<EMEQUIP> selectByEmmachinecategoryid(String emmachinecategoryid) {
        return baseMapper.selectByEmmachinecategoryid(emmachinecategoryid);
    }

    @Override
    public void removeByEmmachinecategoryid(String emmachinecategoryid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("emmachinecategoryid",emmachinecategoryid));
    }

	@Override
    public List<EMEQUIP> selectByEmmachmodelid(String emmachmodelid) {
        return baseMapper.selectByEmmachmodelid(emmachmodelid);
    }

    @Override
    public void removeByEmmachmodelid(String emmachmodelid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("emmachmodelid",emmachmodelid));
    }

	@Override
    public List<EMEQUIP> selectByLabserviceid(String emserviceid) {
        return baseMapper.selectByLabserviceid(emserviceid);
    }

    @Override
    public void removeByLabserviceid(String emserviceid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("labserviceid",emserviceid));
    }

	@Override
    public List<EMEQUIP> selectByMserviceid(String emserviceid) {
        return baseMapper.selectByMserviceid(emserviceid);
    }

    @Override
    public void removeByMserviceid(String emserviceid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("mserviceid",emserviceid));
    }

	@Override
    public List<EMEQUIP> selectByRserviceid(String emserviceid) {
        return baseMapper.selectByRserviceid(emserviceid);
    }

    @Override
    public void removeByRserviceid(String emserviceid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("rserviceid",emserviceid));
    }

	@Override
    public List<EMEQUIP> selectByContractid(String pfcontractid) {
        return baseMapper.selectByContractid(pfcontractid);
    }

    @Override
    public void removeByContractid(String pfcontractid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("contractid",pfcontractid));
    }

	@Override
    public List<EMEQUIP> selectByDeptid(String pfdeptid) {
        return baseMapper.selectByDeptid(pfdeptid);
    }

    @Override
    public void removeByDeptid(String pfdeptid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("deptid",pfdeptid));
    }

	@Override
    public List<EMEQUIP> selectByEmpid(String pfempid) {
        return baseMapper.selectByEmpid(pfempid);
    }

    @Override
    public void removeByEmpid(String pfempid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("empid",pfempid));
    }

	@Override
    public List<EMEQUIP> selectByRteamid(String pfteamid) {
        return baseMapper.selectByRteamid(pfteamid);
    }

    @Override
    public void removeByRteamid(String pfteamid) {
        this.remove(new QueryWrapper<EMEQUIP>().eq("rteamid",pfteamid));
    }


    /**
     * 查询集合 各类型设备数量
     */
    @Override
    public Page<HashMap> searchTypeEQNum(EMEQUIPSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HashMap> pages=baseMapper.searchTypeEQNum(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HashMap>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<EMEQUIP> searchDefault(EMEQUIPSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<EMEQUIP> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<EMEQUIP>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(EMEQUIP et){
        //实体关系[DER1N_EMEQUIP_EMACCLASS_ACCLASSID]
        if(!ObjectUtils.isEmpty(et.getAcclassid())){
            cn.ibizlab.eam.core.eam_core.domain.EMACCLASS acclass=et.getAcclass();
            if(ObjectUtils.isEmpty(acclass)){
                cn.ibizlab.eam.core.eam_core.domain.EMACCLASS majorEntity=emacclassService.get(et.getAcclassid());
                et.setAcclass(majorEntity);
                acclass=majorEntity;
            }
            et.setAcclassname(acclass.getEmacclassname());
        }
        //实体关系[DER1N_EMEQUIP_EMASSET_ASSETID]
        if(!ObjectUtils.isEmpty(et.getAssetid())){
            cn.ibizlab.eam.core.eam_core.domain.EMASSET asset=et.getAsset();
            if(ObjectUtils.isEmpty(asset)){
                cn.ibizlab.eam.core.eam_core.domain.EMASSET majorEntity=emassetService.get(et.getAssetid());
                et.setAsset(majorEntity);
                asset=majorEntity;
            }
            et.setAssetclasscode(asset.getAssetclasscode());
            et.setAssetname(asset.getAssetinfo());
            et.setAssetclassname(asset.getAssetclassname());
            et.setAssetclassid(asset.getAssetclassid());
            et.setAssetcode(asset.getAssetcode());
        }
        //实体关系[DER1N_EMEQUIP_EMBERTH_EMBERTHID]
        if(!ObjectUtils.isEmpty(et.getEmberthid())){
            cn.ibizlab.eam.core.eam_core.domain.EMBERTH emberth=et.getEmberth();
            if(ObjectUtils.isEmpty(emberth)){
                cn.ibizlab.eam.core.eam_core.domain.EMBERTH majorEntity=emberthService.get(et.getEmberthid());
                et.setEmberth(majorEntity);
                emberth=majorEntity;
            }
            et.setEmberthcode(emberth.getEmberthname());
            et.setEmberthname(emberth.getEmberthname());
        }
        //实体关系[DER1N_EMEQUIP_EMBRAND_EMBRANDID]
        if(!ObjectUtils.isEmpty(et.getEmbrandid())){
            cn.ibizlab.eam.core.eam_core.domain.EMBRAND embrand=et.getEmbrand();
            if(ObjectUtils.isEmpty(embrand)){
                cn.ibizlab.eam.core.eam_core.domain.EMBRAND majorEntity=embrandService.get(et.getEmbrandid());
                et.setEmbrand(majorEntity);
                embrand=majorEntity;
            }
            et.setEmbrandcode(embrand.getEmbrandcode());
            et.setEmbrandname(embrand.getEmbrandname());
        }
        //实体关系[DER1N_EMEQUIP_EMEQLOCATION_EQLOCATIONID]
        if(!ObjectUtils.isEmpty(et.getEqlocationid())){
            cn.ibizlab.eam.core.eam_core.domain.EMEQLOCATION eqlocation=et.getEqlocation();
            if(ObjectUtils.isEmpty(eqlocation)){
                cn.ibizlab.eam.core.eam_core.domain.EMEQLOCATION majorEntity=emeqlocationService.get(et.getEqlocationid());
                et.setEqlocation(majorEntity);
                eqlocation=majorEntity;
            }
            et.setEqlocationname(eqlocation.getEqlocationinfo());
            et.setEqlocationcode(eqlocation.getEqlocationcode());
        }
        //实体关系[DER1N_EMEQUIP_EMEQTYPE_EQTYPEID]
        if(!ObjectUtils.isEmpty(et.getEqtypeid())){
            cn.ibizlab.eam.core.eam_core.domain.EMEQTYPE eqtype=et.getEqtype();
            if(ObjectUtils.isEmpty(eqtype)){
                cn.ibizlab.eam.core.eam_core.domain.EMEQTYPE majorEntity=emeqtypeService.get(et.getEqtypeid());
                et.setEqtype(majorEntity);
                eqtype=majorEntity;
            }
            et.setStype(eqtype.getStype());
            et.setEqtypecode(eqtype.getEqtypecode());
            et.setEqtypename(eqtype.getEqtypeinfo());
            et.setSname(eqtype.getSname());
        }
        //实体关系[DER1N_EMEQUIP_EMEQUIP_EQUIPPID]
        if(!ObjectUtils.isEmpty(et.getEquippid())){
            cn.ibizlab.eam.core.eam_core.domain.EMEQUIP equipp=et.getEquipp();
            if(ObjectUtils.isEmpty(equipp)){
                cn.ibizlab.eam.core.eam_core.domain.EMEQUIP majorEntity=emequipService.get(et.getEquippid());
                et.setEquipp(majorEntity);
                equipp=majorEntity;
            }
            et.setEquippcode(equipp.getEquipcode());
            et.setEquippname(equipp.getEquipinfo());
        }
        //实体关系[DER1N_EMEQUIP_EMMACHINECATEGORY_EMMACHINECATEGORYID]
        if(!ObjectUtils.isEmpty(et.getEmmachinecategoryid())){
            cn.ibizlab.eam.core.eam_core.domain.EMMACHINECATEGORY emmachinecategory=et.getEmmachinecategory();
            if(ObjectUtils.isEmpty(emmachinecategory)){
                cn.ibizlab.eam.core.eam_core.domain.EMMACHINECATEGORY majorEntity=emmachinecategoryService.get(et.getEmmachinecategoryid());
                et.setEmmachinecategory(majorEntity);
                emmachinecategory=majorEntity;
            }
            et.setJzbh1(emmachinecategory.getMachtypecode());
            et.setEmmachinecategoryname(emmachinecategory.getJzinfo());
            et.setMachtypecode(emmachinecategory.getMachtypecode());
        }
        //实体关系[DER1N_EMEQUIP_EMMACHMODEL_EMMACHMODELID]
        if(!ObjectUtils.isEmpty(et.getEmmachmodelid())){
            cn.ibizlab.eam.core.eam_core.domain.EMMACHMODEL emmachmodel=et.getEmmachmodel();
            if(ObjectUtils.isEmpty(emmachmodel)){
                cn.ibizlab.eam.core.eam_core.domain.EMMACHMODEL majorEntity=emmachmodelService.get(et.getEmmachmodelid());
                et.setEmmachmodel(majorEntity);
                emmachmodel=majorEntity;
            }
            et.setEmmachmodelname(emmachmodel.getEmmachmodelname());
        }
        //实体关系[DER1N_EMEQUIP_EMSERVICE_LABSERVICEID]
        if(!ObjectUtils.isEmpty(et.getLabserviceid())){
            cn.ibizlab.eam.core.eam_core.domain.EMSERVICE labservice=et.getLabservice();
            if(ObjectUtils.isEmpty(labservice)){
                cn.ibizlab.eam.core.eam_core.domain.EMSERVICE majorEntity=emserviceService.get(et.getLabserviceid());
                et.setLabservice(majorEntity);
                labservice=majorEntity;
            }
            et.setLabservicename(labservice.getServiceinfo());
        }
        //实体关系[DER1N_EMEQUIP_EMSERVICE_MSERVICEID]
        if(!ObjectUtils.isEmpty(et.getMserviceid())){
            cn.ibizlab.eam.core.eam_core.domain.EMSERVICE mservice=et.getMservice();
            if(ObjectUtils.isEmpty(mservice)){
                cn.ibizlab.eam.core.eam_core.domain.EMSERVICE majorEntity=emserviceService.get(et.getMserviceid());
                et.setMservice(majorEntity);
                mservice=majorEntity;
            }
            et.setMservicename(mservice.getServiceinfo());
        }
        //实体关系[DER1N_EMEQUIP_EMSERVICE_RSERVICEID]
        if(!ObjectUtils.isEmpty(et.getRserviceid())){
            cn.ibizlab.eam.core.eam_core.domain.EMSERVICE rservice=et.getRservice();
            if(ObjectUtils.isEmpty(rservice)){
                cn.ibizlab.eam.core.eam_core.domain.EMSERVICE majorEntity=emserviceService.get(et.getRserviceid());
                et.setRservice(majorEntity);
                rservice=majorEntity;
            }
            et.setRservicename(rservice.getServiceinfo());
        }
        //实体关系[DER1N_EMEQUIP_PFCONTRACT_CONTRACTID]
        if(!ObjectUtils.isEmpty(et.getContractid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFCONTRACT contract=et.getContract();
            if(ObjectUtils.isEmpty(contract)){
                cn.ibizlab.eam.core.eam_pf.domain.PFCONTRACT majorEntity=pfcontractService.get(et.getContractid());
                et.setContract(majorEntity);
                contract=majorEntity;
            }
            et.setContractname(contract.getContractinfo());
        }
        //实体关系[DER1N_EMEQUIP_PFDEPT_DEPTID]
        if(!ObjectUtils.isEmpty(et.getDeptid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFDEPT dept=et.getDept();
            if(ObjectUtils.isEmpty(dept)){
                cn.ibizlab.eam.core.eam_pf.domain.PFDEPT majorEntity=pfdeptService.get(et.getDeptid());
                et.setDept(majorEntity);
                dept=majorEntity;
            }
            et.setDeptname(dept.getDeptinfo());
        }
        //实体关系[DER1N_EMEQUIP_PFEMP_EMPID]
        if(!ObjectUtils.isEmpty(et.getEmpid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFEMP emp=et.getEmp();
            if(ObjectUtils.isEmpty(emp)){
                cn.ibizlab.eam.core.eam_pf.domain.PFEMP majorEntity=pfempService.get(et.getEmpid());
                et.setEmp(majorEntity);
                emp=majorEntity;
            }
            et.setEmpname(emp.getEmpinfo());
        }
        //实体关系[DER1N_EMEQUIP_PFTEAM_RTEAMID]
        if(!ObjectUtils.isEmpty(et.getRteamid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFTEAM rteam=et.getRteam();
            if(ObjectUtils.isEmpty(rteam)){
                cn.ibizlab.eam.core.eam_pf.domain.PFTEAM majorEntity=pfteamService.get(et.getRteamid());
                et.setRteam(majorEntity);
                rteam=majorEntity;
            }
            et.setRteamname(rteam.getTeaminfo());
        }
    }

    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


