package cn.ibizlab.eam.core.eam_core.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.eam.core.eam_core.domain.EMMACHMODEL;
import cn.ibizlab.eam.core.eam_core.filter.EMMACHMODELSearchContext;
import cn.ibizlab.eam.core.eam_core.service.IEMMACHMODELService;

import cn.ibizlab.eam.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.eam.core.eam_core.mapper.EMMACHMODELMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[机型] 服务对象接口实现
 */
@Slf4j
@Service("EMMACHMODELServiceImpl")
public class EMMACHMODELServiceImpl extends ServiceImpl<EMMACHMODELMapper, EMMACHMODEL> implements IEMMACHMODELService {

    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQUIPService emequipService;

    private int batchSize = 500;

    @Override
    public EMMACHMODEL getDraft(EMMACHMODEL et) {
        return et;
    }

    @Override
    @Transactional
    public boolean create(EMMACHMODEL et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getEmmachmodelid()),et);
        return true;
    }

    @Override
    public void createBatch(List<EMMACHMODEL> list) {
        saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public EMMACHMODEL get(String key) {
        EMMACHMODEL et = getById(key);
        if(et==null){
            et=new EMMACHMODEL();
            et.setEmmachmodelid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean update(EMMACHMODEL et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("emmachmodelid",et.getEmmachmodelid())))
            return false;
        CachedBeanCopier.copy(get(et.getEmmachmodelid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<EMMACHMODEL> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean save(EMMACHMODEL et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(EMMACHMODEL et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<EMMACHMODEL> list) {
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    public boolean checkKey(EMMACHMODEL et) {
        return (!ObjectUtils.isEmpty(et.getEmmachmodelid()))&&(!Objects.isNull(this.getById(et.getEmmachmodelid())));
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<EMMACHMODEL> searchDefault(EMMACHMODELSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<EMMACHMODEL> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<EMMACHMODEL>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


