package cn.ibizlab.eam.core.eam_core.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.eam.core.eam_core.domain.EMOUTPUTRCT;
import cn.ibizlab.eam.core.eam_core.filter.EMOUTPUTRCTSearchContext;
import cn.ibizlab.eam.core.eam_core.service.IEMOUTPUTRCTService;

import cn.ibizlab.eam.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.eam.core.eam_core.mapper.EMOUTPUTRCTMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[产能] 服务对象接口实现
 */
@Slf4j
@Service("EMOUTPUTRCTServiceImpl")
public class EMOUTPUTRCTServiceImpl extends ServiceImpl<EMOUTPUTRCTMapper, EMOUTPUTRCT> implements IEMOUTPUTRCTService {

    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQUIPService emequipService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMOBJECTService emobjectService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMOUTPUTService emoutputService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWOService emwoService;

    private int batchSize = 500;

    @Override
    @Transactional
    public EMOUTPUTRCT get(String key) {
        EMOUTPUTRCT et = getById(key);
        if(et==null){
            et=new EMOUTPUTRCT();
            et.setEmoutputrctid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean create(EMOUTPUTRCT et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getEmoutputrctid()),et);
        return true;
    }

    @Override
    public void createBatch(List<EMOUTPUTRCT> list) {
        list.forEach(item->fillParentData(item));
        saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean save(EMOUTPUTRCT et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(EMOUTPUTRCT et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<EMOUTPUTRCT> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    public EMOUTPUTRCT getDraft(EMOUTPUTRCT et) {
        fillParentData(et);
        return et;
    }

    @Override
    @Transactional
    public boolean update(EMOUTPUTRCT et) {
        fillParentData(et);
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("emoutputrctid",et.getEmoutputrctid())))
            return false;
        CachedBeanCopier.copy(get(et.getEmoutputrctid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<EMOUTPUTRCT> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    public boolean checkKey(EMOUTPUTRCT et) {
        return (!ObjectUtils.isEmpty(et.getEmoutputrctid()))&&(!Objects.isNull(this.getById(et.getEmoutputrctid())));
    }


	@Override
    public List<EMOUTPUTRCT> selectByEquipid(String emequipid) {
        return baseMapper.selectByEquipid(emequipid);
    }

    @Override
    public void removeByEquipid(String emequipid) {
        this.remove(new QueryWrapper<EMOUTPUTRCT>().eq("equipid",emequipid));
    }

	@Override
    public List<EMOUTPUTRCT> selectByObjid(String emobjectid) {
        return baseMapper.selectByObjid(emobjectid);
    }

    @Override
    public void removeByObjid(String emobjectid) {
        this.remove(new QueryWrapper<EMOUTPUTRCT>().eq("objid",emobjectid));
    }

	@Override
    public List<EMOUTPUTRCT> selectByOutputid(String emoutputid) {
        return baseMapper.selectByOutputid(emoutputid);
    }

    @Override
    public void removeByOutputid(String emoutputid) {
        this.remove(new QueryWrapper<EMOUTPUTRCT>().eq("outputid",emoutputid));
    }

	@Override
    public List<EMOUTPUTRCT> selectByWoid(String emwoid) {
        return baseMapper.selectByWoid(emwoid);
    }

    @Override
    public void removeByWoid(String emwoid) {
        this.remove(new QueryWrapper<EMOUTPUTRCT>().eq("woid",emwoid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<EMOUTPUTRCT> searchDefault(EMOUTPUTRCTSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<EMOUTPUTRCT> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<EMOUTPUTRCT>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(EMOUTPUTRCT et){
        //实体关系[DER1N_EMOUTPUTRCT_EMEQUIP_EQUIPID]
        if(!ObjectUtils.isEmpty(et.getEquipid())){
            cn.ibizlab.eam.core.eam_core.domain.EMEQUIP equip=et.getEquip();
            if(ObjectUtils.isEmpty(equip)){
                cn.ibizlab.eam.core.eam_core.domain.EMEQUIP majorEntity=emequipService.get(et.getEquipid());
                et.setEquip(majorEntity);
                equip=majorEntity;
            }
            et.setEquipname(equip.getEquipinfo());
        }
        //实体关系[DER1N_EMOUTPUTRCT_EMOBJECT_OBJID]
        if(!ObjectUtils.isEmpty(et.getObjid())){
            cn.ibizlab.eam.core.eam_core.domain.EMOBJECT obj=et.getObj();
            if(ObjectUtils.isEmpty(obj)){
                cn.ibizlab.eam.core.eam_core.domain.EMOBJECT majorEntity=emobjectService.get(et.getObjid());
                et.setObj(majorEntity);
                obj=majorEntity;
            }
            et.setObjname(obj.getObjectinfo());
        }
        //实体关系[DER1N_EMOUTPUTRCT_EMOUTPUT_OUTPUTID]
        if(!ObjectUtils.isEmpty(et.getOutputid())){
            cn.ibizlab.eam.core.eam_core.domain.EMOUTPUT output=et.getOutput();
            if(ObjectUtils.isEmpty(output)){
                cn.ibizlab.eam.core.eam_core.domain.EMOUTPUT majorEntity=emoutputService.get(et.getOutputid());
                et.setOutput(majorEntity);
                output=majorEntity;
            }
            et.setOutputname(output.getOutputinfo());
        }
        //实体关系[DER1N_EMOUTPUTRCT_EMWO_WOID]
        if(!ObjectUtils.isEmpty(et.getWoid())){
            cn.ibizlab.eam.core.eam_core.domain.EMWO wo=et.getWo();
            if(ObjectUtils.isEmpty(wo)){
                cn.ibizlab.eam.core.eam_core.domain.EMWO majorEntity=emwoService.get(et.getWoid());
                et.setWo(majorEntity);
                wo=majorEntity;
            }
            et.setWoname(wo.getWoinfo());
        }
    }

    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


