package cn.ibizlab.eam.core.eam_core.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.eam.core.eam_core.domain.EMPURPLAN;
import cn.ibizlab.eam.core.eam_core.filter.EMPURPLANSearchContext;
import cn.ibizlab.eam.core.eam_core.service.IEMPURPLANService;

import cn.ibizlab.eam.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.eam.core.eam_core.mapper.EMPURPLANMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[计划修理] 服务对象接口实现
 */
@Slf4j
@Service("EMPURPLANServiceImpl")
public class EMPURPLANServiceImpl extends ServiceImpl<EMPURPLANMapper, EMPURPLAN> implements IEMPURPLANService {

    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMBIDINQUIRYService embidinquiryService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMPUSEService emitempuseService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPROJECTTRACKService emprojecttrackService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMTYPEService emitemtypeService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFEMPService pfempService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFUNITService pfunitService;

    private int batchSize = 500;

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public boolean update(EMPURPLAN et) {
        fillParentData(et);
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("empurplanid",et.getEmpurplanid())))
            return false;
        CachedBeanCopier.copy(get(et.getEmpurplanid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<EMPURPLAN> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean create(EMPURPLAN et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getEmpurplanid()),et);
        return true;
    }

    @Override
    public void createBatch(List<EMPURPLAN> list) {
        list.forEach(item->fillParentData(item));
        saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean save(EMPURPLAN et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(EMPURPLAN et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<EMPURPLAN> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    @Transactional
    public EMPURPLAN get(String key) {
        EMPURPLAN et = getById(key);
        if(et==null){
            et=new EMPURPLAN();
            et.setEmpurplanid(key);
        }
        else{
        }
        return et;
    }

    @Override
    public EMPURPLAN getDraft(EMPURPLAN et) {
        fillParentData(et);
        return et;
    }

    @Override
    public boolean checkKey(EMPURPLAN et) {
        return (!ObjectUtils.isEmpty(et.getEmpurplanid()))&&(!Objects.isNull(this.getById(et.getEmpurplanid())));
    }


	@Override
    public List<EMPURPLAN> selectByEmbidinquiryid(String embidinquiryid) {
        return baseMapper.selectByEmbidinquiryid(embidinquiryid);
    }

    @Override
    public void removeByEmbidinquiryid(String embidinquiryid) {
        this.remove(new QueryWrapper<EMPURPLAN>().eq("embidinquiryid",embidinquiryid));
    }

	@Override
    public List<EMPURPLAN> selectByItemtypeid(String emitemtypeid) {
        return baseMapper.selectByItemtypeid(emitemtypeid);
    }

    @Override
    public void removeByItemtypeid(String emitemtypeid) {
        this.remove(new QueryWrapper<EMPURPLAN>().eq("itemtypeid",emitemtypeid));
    }

	@Override
    public List<EMPURPLAN> selectByRempid(String pfempid) {
        return baseMapper.selectByRempid(pfempid);
    }

    @Override
    public void removeByRempid(String pfempid) {
        this.remove(new QueryWrapper<EMPURPLAN>().eq("rempid",pfempid));
    }

	@Override
    public List<EMPURPLAN> selectByUnitid(String pfunitid) {
        return baseMapper.selectByUnitid(pfunitid);
    }

    @Override
    public void removeByUnitid(String pfunitid) {
        this.remove(new QueryWrapper<EMPURPLAN>().eq("unitid",pfunitid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<EMPURPLAN> searchDefault(EMPURPLANSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<EMPURPLAN> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<EMPURPLAN>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(EMPURPLAN et){
        //实体关系[DER1N_EMPURPLAN_EMBIDINQUIRY_EMBIDINQUIRYID]
        if(!ObjectUtils.isEmpty(et.getEmbidinquiryid())){
            cn.ibizlab.eam.core.eam_core.domain.EMBIDINQUIRY embidinquiry=et.getEmbidinquiry();
            if(ObjectUtils.isEmpty(embidinquiry)){
                cn.ibizlab.eam.core.eam_core.domain.EMBIDINQUIRY majorEntity=embidinquiryService.get(et.getEmbidinquiryid());
                et.setEmbidinquiry(majorEntity);
                embidinquiry=majorEntity;
            }
            et.setEmbidinquiryname(embidinquiry.getEmbidinquiryname());
        }
        //实体关系[DER1N_EMPURPLAN_EMITEMTYPE_ITEMTYPEID]
        if(!ObjectUtils.isEmpty(et.getItemtypeid())){
            cn.ibizlab.eam.core.eam_core.domain.EMITEMTYPE itemtype=et.getItemtype();
            if(ObjectUtils.isEmpty(itemtype)){
                cn.ibizlab.eam.core.eam_core.domain.EMITEMTYPE majorEntity=emitemtypeService.get(et.getItemtypeid());
                et.setItemtype(majorEntity);
                itemtype=majorEntity;
            }
            et.setItemtypename(itemtype.getItemtypeinfo());
        }
        //实体关系[DER1N_EMPURPLAN_PFEMP_REMPID]
        if(!ObjectUtils.isEmpty(et.getRempid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFEMP remp=et.getRemp();
            if(ObjectUtils.isEmpty(remp)){
                cn.ibizlab.eam.core.eam_pf.domain.PFEMP majorEntity=pfempService.get(et.getRempid());
                et.setRemp(majorEntity);
                remp=majorEntity;
            }
            et.setRempname(remp.getEmpinfo());
        }
        //实体关系[DER1N_EMPURPLAN_PFUNIT_UNITID]
        if(!ObjectUtils.isEmpty(et.getUnitid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFUNIT unit=et.getUnit();
            if(ObjectUtils.isEmpty(unit)){
                cn.ibizlab.eam.core.eam_pf.domain.PFUNIT majorEntity=pfunitService.get(et.getUnitid());
                et.setUnit(majorEntity);
                unit=majorEntity;
            }
            et.setUnitname(unit.getPfunitname());
        }
    }

    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


