package cn.ibizlab.eam.core.eam_pf.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_pf.domain.PFCONTRACT;
import cn.ibizlab.eam.core.eam_pf.filter.PFCONTRACTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PFCONTRACT] 服务对象接口
 */
public interface IPFCONTRACTService extends IService<PFCONTRACT>{

    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    PFCONTRACT get(String key) ;
    PFCONTRACT getDraft(PFCONTRACT et) ;
    boolean save(PFCONTRACT et) ;
    void saveBatch(List<PFCONTRACT> list) ;
    boolean checkKey(PFCONTRACT et) ;
    boolean update(PFCONTRACT et) ;
    void updateBatch(List<PFCONTRACT> list) ;
    boolean create(PFCONTRACT et) ;
    void createBatch(List<PFCONTRACT> list) ;
    Page<PFCONTRACT> searchDefault(PFCONTRACTSearchContext context) ;
    List<PFCONTRACT> selectByEmserviceid(String emserviceid) ;
    void removeByEmserviceid(String emserviceid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


