package cn.ibizlab.eam.core.eam_pf.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_pf.domain.PFDEPT;
import cn.ibizlab.eam.core.eam_pf.filter.PFDEPTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PFDEPT] 服务对象接口
 */
public interface IPFDEPTService extends IService<PFDEPT>{

    boolean save(PFDEPT et) ;
    void saveBatch(List<PFDEPT> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(PFDEPT et) ;
    void createBatch(List<PFDEPT> list) ;
    PFDEPT getDraft(PFDEPT et) ;
    PFDEPT get(String key) ;
    boolean update(PFDEPT et) ;
    void updateBatch(List<PFDEPT> list) ;
    boolean checkKey(PFDEPT et) ;
    Page<PFDEPT> searchDefault(PFDEPTSearchContext context) ;
    List<PFDEPT> selectByDeptpid(String pfdeptid) ;
    void removeByDeptpid(String pfdeptid) ;
    List<PFDEPT> selectByMgrempid(String pfempid) ;
    void removeByMgrempid(String pfempid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


