package cn.ibizlab.eam.core.eam_pf.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_pf.domain.PFEMPPOSTMAP;
import cn.ibizlab.eam.core.eam_pf.filter.PFEMPPOSTMAPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PFEMPPOSTMAP] 服务对象接口
 */
public interface IPFEMPPOSTMAPService extends IService<PFEMPPOSTMAP>{

    PFEMPPOSTMAP get(String key) ;
    boolean create(PFEMPPOSTMAP et) ;
    void createBatch(List<PFEMPPOSTMAP> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    PFEMPPOSTMAP getDraft(PFEMPPOSTMAP et) ;
    boolean save(PFEMPPOSTMAP et) ;
    void saveBatch(List<PFEMPPOSTMAP> list) ;
    boolean checkKey(PFEMPPOSTMAP et) ;
    boolean update(PFEMPPOSTMAP et) ;
    void updateBatch(List<PFEMPPOSTMAP> list) ;
    Page<PFEMPPOSTMAP> searchDefault(PFEMPPOSTMAPSearchContext context) ;
    List<PFEMPPOSTMAP> selectByDeptid(String pfdeptid) ;
    void removeByDeptid(String pfdeptid) ;
    List<PFEMPPOSTMAP> selectByEmpid(String pfempid) ;
    void removeByEmpid(String pfempid) ;
    List<PFEMPPOSTMAP> selectByPostid(String pfpostid) ;
    void removeByPostid(String pfpostid) ;
    List<PFEMPPOSTMAP> selectByTeamid(String pfteamid) ;
    void removeByTeamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


