package cn.ibizlab.eam.core.eam_pf.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_pf.domain.PFEMP;
import cn.ibizlab.eam.core.eam_pf.filter.PFEMPSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PFEMP] 服务对象接口
 */
public interface IPFEMPService extends IService<PFEMP>{

    boolean create(PFEMP et) ;
    void createBatch(List<PFEMP> list) ;
    PFEMP get(String key) ;
    boolean update(PFEMP et) ;
    void updateBatch(List<PFEMP> list) ;
    boolean save(PFEMP et) ;
    void saveBatch(List<PFEMP> list) ;
    boolean checkKey(PFEMP et) ;
    PFEMP getDraft(PFEMP et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<PFEMP> searchDefault(PFEMPSearchContext context) ;
    List<PFEMP> selectByMajordeptid(String pfdeptid) ;
    void removeByMajordeptid(String pfdeptid) ;
    List<PFEMP> selectByMajorteamid(String pfteamid) ;
    void removeByMajorteamid(String pfteamid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


