package cn.ibizlab.eam.core.eam_pf.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_pf.domain.PFORG;
import cn.ibizlab.eam.core.eam_pf.filter.PFORGSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PFORG] 服务对象接口
 */
public interface IPFORGService extends IService<PFORG>{

    PFORG getDraft(PFORG et) ;
    boolean checkKey(PFORG et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    PFORG get(String key) ;
    boolean create(PFORG et) ;
    void createBatch(List<PFORG> list) ;
    boolean update(PFORG et) ;
    void updateBatch(List<PFORG> list) ;
    boolean save(PFORG et) ;
    void saveBatch(List<PFORG> list) ;
    Page<PFORG> searchDefault(PFORGSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


