package cn.ibizlab.eam.core.eam_pf.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_pf.domain.PFPOST;
import cn.ibizlab.eam.core.eam_pf.filter.PFPOSTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PFPOST] 服务对象接口
 */
public interface IPFPOSTService extends IService<PFPOST>{

    PFPOST getDraft(PFPOST et) ;
    boolean update(PFPOST et) ;
    void updateBatch(List<PFPOST> list) ;
    PFPOST get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean create(PFPOST et) ;
    void createBatch(List<PFPOST> list) ;
    boolean save(PFPOST et) ;
    void saveBatch(List<PFPOST> list) ;
    boolean checkKey(PFPOST et) ;
    Page<PFPOST> searchDefault(PFPOSTSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


