package cn.ibizlab.eam.core.eam_pf.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_pf.domain.PFTEAM;
import cn.ibizlab.eam.core.eam_pf.filter.PFTEAMSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PFTEAM] 服务对象接口
 */
public interface IPFTEAMService extends IService<PFTEAM>{

    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    PFTEAM getDraft(PFTEAM et) ;
    boolean save(PFTEAM et) ;
    void saveBatch(List<PFTEAM> list) ;
    boolean create(PFTEAM et) ;
    void createBatch(List<PFTEAM> list) ;
    boolean checkKey(PFTEAM et) ;
    boolean update(PFTEAM et) ;
    void updateBatch(List<PFTEAM> list) ;
    PFTEAM get(String key) ;
    Page<PFTEAM> searchDefault(PFTEAMSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


