package cn.ibizlab.eam.core.eam_pf.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;

import cn.ibizlab.eam.core.eam_pf.domain.PFUNIT;
import cn.ibizlab.eam.core.eam_pf.filter.PFUNITSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[PFUNIT] 服务对象接口
 */
public interface IPFUNITService extends IService<PFUNIT>{

    boolean checkKey(PFUNIT et) ;
    PFUNIT getDraft(PFUNIT et) ;
    boolean update(PFUNIT et) ;
    void updateBatch(List<PFUNIT> list) ;
    boolean save(PFUNIT et) ;
    void saveBatch(List<PFUNIT> list) ;
    PFUNIT get(String key) ;
    boolean create(PFUNIT et) ;
    void createBatch(List<PFUNIT> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<PFUNIT> searchDefault(PFUNITSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


