package cn.ibizlab.eam.core.eam_pf.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.eam.core.eam_pf.domain.PFDEPT;
import cn.ibizlab.eam.core.eam_pf.filter.PFDEPTSearchContext;
import cn.ibizlab.eam.core.eam_pf.service.IPFDEPTService;

import cn.ibizlab.eam.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.eam.core.eam_pf.mapper.PFDEPTMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[部门] 服务对象接口实现
 */
@Slf4j
@Service("PFDEPTServiceImpl")
public class PFDEPTServiceImpl extends ServiceImpl<PFDEPTMapper, PFDEPT> implements IPFDEPTService {

    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMAPPLYService emapplyService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMASSETService emassetService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMENCONSUMService emenconsumService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQAHService emeqahService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQCHECKService emeqcheckService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQDEBUGService emeqdebugService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQKEEPService emeqkeepService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQMAINTANCEService emeqmaintanceService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQSETUPService emeqsetupService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQUIPService emequipService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMPUSEService emitempuseService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMTRADEService emitemtradeService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMJYJLService emjyjlService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPLANTEMPLService emplantemplService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPLANService emplanService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPRODUCTService emproductService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPURCHANGEHISService empurchangehisService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_DPService emwoDpService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_ENService emwoEnService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_INNERService emwoInnerService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_OSCService emwoOscService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWOService emwoService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_PTService emwoPtService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWPLISTService emwplistService;

    private cn.ibizlab.eam.core.eam_pf.service.IPFDEPTService pfdeptService = this;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFEMPPOSTMAPService pfemppostmapService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFEMPService pfempService;

    private int batchSize = 500;

    @Override
    @Transactional
    public boolean save(PFDEPT et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(PFDEPT et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<PFDEPT> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public boolean create(PFDEPT et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getPfdeptid()),et);
        return true;
    }

    @Override
    public void createBatch(List<PFDEPT> list) {
        list.forEach(item->fillParentData(item));
        saveBatch(list,batchSize);
    }

    @Override
    public PFDEPT getDraft(PFDEPT et) {
        fillParentData(et);
        return et;
    }

    @Override
    @Transactional
    public PFDEPT get(String key) {
        PFDEPT et = getById(key);
        if(et==null){
            et=new PFDEPT();
            et.setPfdeptid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean update(PFDEPT et) {
        fillParentData(et);
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("pfdeptid",et.getPfdeptid())))
            return false;
        CachedBeanCopier.copy(get(et.getPfdeptid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<PFDEPT> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    public boolean checkKey(PFDEPT et) {
        return (!ObjectUtils.isEmpty(et.getPfdeptid()))&&(!Objects.isNull(this.getById(et.getPfdeptid())));
    }


	@Override
    public List<PFDEPT> selectByDeptpid(String pfdeptid) {
        return baseMapper.selectByDeptpid(pfdeptid);
    }

    @Override
    public void removeByDeptpid(String pfdeptid) {
        this.remove(new QueryWrapper<PFDEPT>().eq("deptpid",pfdeptid));
    }

	@Override
    public List<PFDEPT> selectByMgrempid(String pfempid) {
        return baseMapper.selectByMgrempid(pfempid);
    }

    @Override
    public void removeByMgrempid(String pfempid) {
        this.remove(new QueryWrapper<PFDEPT>().eq("mgrempid",pfempid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PFDEPT> searchDefault(PFDEPTSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PFDEPT> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<PFDEPT>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(PFDEPT et){
        //实体关系[DER1N_PFDEPT_PFDEPT_DEPTPID]
        if(!ObjectUtils.isEmpty(et.getDeptpid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFDEPT deptp=et.getDeptp();
            if(ObjectUtils.isEmpty(deptp)){
                cn.ibizlab.eam.core.eam_pf.domain.PFDEPT majorEntity=pfdeptService.get(et.getDeptpid());
                et.setDeptp(majorEntity);
                deptp=majorEntity;
            }
            et.setDeptpname(deptp.getDeptinfo());
        }
        //实体关系[DER1N_PFDEPT_PFEMP_MGREMPID]
        if(!ObjectUtils.isEmpty(et.getMgrempid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFEMP mgremp=et.getMgremp();
            if(ObjectUtils.isEmpty(mgremp)){
                cn.ibizlab.eam.core.eam_pf.domain.PFEMP majorEntity=pfempService.get(et.getMgrempid());
                et.setMgremp(majorEntity);
                mgremp=majorEntity;
            }
            et.setMgrempname(mgremp.getEmpinfo());
        }
    }

    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


