package cn.ibizlab.eam.core.eam_pf.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.eam.core.eam_pf.domain.PFEMP;
import cn.ibizlab.eam.core.eam_pf.filter.PFEMPSearchContext;
import cn.ibizlab.eam.core.eam_pf.service.IPFEMPService;

import cn.ibizlab.eam.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.eam.core.eam_pf.mapper.PFEMPMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[职员] 服务对象接口实现
 */
@Slf4j
@Service("PFEMPServiceImpl")
public class PFEMPServiceImpl extends ServiceImpl<PFEMPMapper, PFEMP> implements IPFEMPService {

    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMAPPLYService emapplyService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMASSESSMENTMXService emassessmentmxService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMASSESSMENTService emassessmentService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMASSESSService emassessService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMASSETHISTService emassethistService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMASSETService emassetService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMBIDINQUIRYService embidinquiryService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMDRWGService emdrwgService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEIBATTERYFILLService emeibatteryfillService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEIBATTERYHISTService emeibatteryhistService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEIBATTERYSETUPService emeibatterysetupService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEIBATTERYService emeibatteryService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICAMDROPService emeicamdropService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICAMHISTService emeicamhistService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICAMSETUPService emeicamsetupService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICAMService emeicamService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICELLHISTService emeicellhistService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICELLRETURNService emeicellreturnService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICELLSETUPService emeicellsetupService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEICELLService emeicellService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEIREPORTMService emeireportmService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEITIRESService emeitiresService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEITOOLService emeitoolService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQAHService emeqahService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQCHECKService emeqcheckService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQDEBUGService emeqdebugService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQKEEPService emeqkeepService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQMAINTANCEService emeqmaintanceService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQSETUPService emeqsetupService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMEQUIPService emequipService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMCSService emitemcsService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMPLService emitemplService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMPRTNService emitemprtnService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMPUSEService emitempuseService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMRINService emitemrinService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMROUTService emitemroutService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMTRADEService emitemtradeService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMService emitemService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMJYJLService emjyjlService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPLANDETAILService emplandetailService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPLANTDETAILService emplantdetailService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPLANTEMPLService emplantemplService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPLANService emplanService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPODETAILService empodetailService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPOService empoService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPRODUCTService emproductService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPROJECTTRACKService emprojecttrackService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPURCHANGEHISService empurchangehisService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPURPLANService empurplanService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMRESEMPService emresempService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMSERVICEEVLService emserviceevlService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMSTOREService emstoreService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWORKService emworkService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_DPService emwoDpService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_ENService emwoEnService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_INNERService emwoInnerService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_OSCService emwoOscService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWOService emwoService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWO_PTService emwoPtService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWPLISTCOSTService emwplistcostService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWPLISTService emwplistService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFDEPTService pfdeptService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFEMPPOSTMAPService pfemppostmapService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_pf.service.IPFTEAMService pfteamService;

    private int batchSize = 500;

    @Override
    @Transactional
    public boolean create(PFEMP et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getPfempid()),et);
        return true;
    }

    @Override
    public void createBatch(List<PFEMP> list) {
        list.forEach(item->fillParentData(item));
        saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public PFEMP get(String key) {
        PFEMP et = getById(key);
        if(et==null){
            et=new PFEMP();
            et.setPfempid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean update(PFEMP et) {
        fillParentData(et);
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("pfempid",et.getPfempid())))
            return false;
        CachedBeanCopier.copy(get(et.getPfempid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<PFEMP> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean save(PFEMP et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(PFEMP et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<PFEMP> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    public boolean checkKey(PFEMP et) {
        return (!ObjectUtils.isEmpty(et.getPfempid()))&&(!Objects.isNull(this.getById(et.getPfempid())));
    }

    @Override
    public PFEMP getDraft(PFEMP et) {
        fillParentData(et);
        return et;
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }


	@Override
    public List<PFEMP> selectByMajordeptid(String pfdeptid) {
        return baseMapper.selectByMajordeptid(pfdeptid);
    }

    @Override
    public void removeByMajordeptid(String pfdeptid) {
        this.remove(new QueryWrapper<PFEMP>().eq("majordeptid",pfdeptid));
    }

	@Override
    public List<PFEMP> selectByMajorteamid(String pfteamid) {
        return baseMapper.selectByMajorteamid(pfteamid);
    }

    @Override
    public void removeByMajorteamid(String pfteamid) {
        this.remove(new QueryWrapper<PFEMP>().eq("majorteamid",pfteamid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PFEMP> searchDefault(PFEMPSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PFEMP> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<PFEMP>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(PFEMP et){
        //实体关系[DER1N_PFEMP_PFDEPT_MAJORDEPTID]
        if(!ObjectUtils.isEmpty(et.getMajordeptid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFDEPT majordept=et.getMajordept();
            if(ObjectUtils.isEmpty(majordept)){
                cn.ibizlab.eam.core.eam_pf.domain.PFDEPT majorEntity=pfdeptService.get(et.getMajordeptid());
                et.setMajordept(majorEntity);
                majordept=majorEntity;
            }
            et.setMajordeptname(majordept.getDeptinfo());
        }
        //实体关系[DER1N_PFEMP_PFTEAM_MAJORTEAMID]
        if(!ObjectUtils.isEmpty(et.getMajorteamid())){
            cn.ibizlab.eam.core.eam_pf.domain.PFTEAM majorteam=et.getMajorteam();
            if(ObjectUtils.isEmpty(majorteam)){
                cn.ibizlab.eam.core.eam_pf.domain.PFTEAM majorEntity=pfteamService.get(et.getMajorteamid());
                et.setMajorteam(majorEntity);
                majorteam=majorEntity;
            }
            et.setMajorteamname(majorteam.getTeaminfo());
        }
    }

    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


