package cn.ibizlab.eam.core.eam_pf.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.eam.core.eam_pf.domain.PFUNIT;
import cn.ibizlab.eam.core.eam_pf.filter.PFUNITSearchContext;
import cn.ibizlab.eam.core.eam_pf.service.IPFUNITService;

import cn.ibizlab.eam.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.eam.core.eam_pf.mapper.PFUNITMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[计量单位] 服务对象接口实现
 */
@Slf4j
@Service("PFUNITServiceImpl")
public class PFUNITServiceImpl extends ServiceImpl<PFUNITMapper, PFUNIT> implements IPFUNITService {

    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMASSETService emassetService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMITEMService emitemService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPODETAILService empodetailService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMPURPLANService empurplanService;
    @Autowired
    @Lazy
    private cn.ibizlab.eam.core.eam_core.service.IEMWPLISTCOSTService emwplistcostService;

    private int batchSize = 500;

    @Override
    public boolean checkKey(PFUNIT et) {
        return (!ObjectUtils.isEmpty(et.getPfunitid()))&&(!Objects.isNull(this.getById(et.getPfunitid())));
    }

    @Override
    public PFUNIT getDraft(PFUNIT et) {
        return et;
    }

    @Override
    @Transactional
    public boolean update(PFUNIT et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("pfunitid",et.getPfunitid())))
            return false;
        CachedBeanCopier.copy(get(et.getPfunitid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<PFUNIT> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean save(PFUNIT et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(PFUNIT et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<PFUNIT> list) {
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    @Transactional
    public PFUNIT get(String key) {
        PFUNIT et = getById(key);
        if(et==null){
            et=new PFUNIT();
            et.setPfunitid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean create(PFUNIT et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getPfunitid()),et);
        return true;
    }

    @Override
    public void createBatch(List<PFUNIT> list) {
        saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PFUNIT> searchDefault(PFUNITSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PFUNIT> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<PFUNIT>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


